cd $TOP
file=Makefile
echo "Extracting $file"
rm -f $file
tarfile=pari-$version.tar

cat > $file << EOT
#
# This file was created by Configure. All changes made will be lost
# next time Configure is run.
#
dft gp all test test-compat install clean:
	cd $objdir; make \$@

doc:
	cd doc; make

exp:
	@if test -d src.orig; then \\
	   echo "Remove src.orig before building an experimental release";\\
	   false; fi
	mv src src.orig
	cp -pr src.orig exp
	ln -s exp src
	mv configure/version configure/version.orig
	sed "s,patch_level=.*,patch_level=exp," \\
	    < configure/version.orig > configure/version

pl$next_patch: exp
	sed "s,patch_level=.*,patch_level=$next_patch," \\
	    < configure/version.orig > configure/version
	-diff -c configure/version.orig configure/version > pl$next_patch
	for i in \`find exp -type f -print\`; do \\
	    diff -c \`echo \$\$i|sed s,exp/,src.orig/,\` \$\$i; done \\
	    | sed s,exp/,src/, >> pl$next_patch

rel: pl$next_patch
	rm -f src
	mv exp src

RCS::
	cd src; ci -l -r\$\${REVISION:-$revision} -m"." *.[ch]

bigdistrib: tar
	tar rf $tarfile doc/app* doc/usersch* doc/*.in doc/Makefile
	gzip $tarfile

distrib: tar
	gzip $tarfile

tar::
	tar FcfX $tarfile $config_dir/tar_exclude -I $config_dir/tar_include
EOT
