/*******************************************************************/
/*******************************************************************/
/*                                                                 */
/*                OPERATIONS DANS LES CORPS DE NOMBRES             */
/*                            (suite)                              */
/*                                                                 */
/*******************************************************************/
/*******************************************************************/
/* $Id: base5.c,v 1.914.7.1 1997/01/19 16:18:09 karim Exp karim $ */
#include "genpari.h"

GEN
matbasistoalg(GEN nf,GEN x)
{
  long i,j,lx,li;
  GEN p1,z;

  if (typ(x)!=t_MAT)
    err(talker,"argument must be a matrix in matbasistoalg");
  lx=lg(x); z=cgetg(lx,t_MAT); if (lx==1) return z;

  li=lg(x[1]);
  for (j=1; j<lx; j++)
  {
    p1=cgetg(li,t_COL); z[j]=(long)p1;
    for (i=1; i<li; i++) p1[i]=(long)basistoalg(nf,gcoeff(x,i,j));
  }
  return z;
}

GEN
matalgtobasis(GEN nf,GEN x)
{
  long i,j,lx,li;
  GEN p1,z;

  if (typ(x)!=t_MAT)
    err(talker,"argument must be a matrix in matalgtobasis");
  lx=lg(x); z=cgetg(lx,t_MAT); if (lx==1) return z;

  li=lg(x[1]);
  for (j=1; j<lx; j++)
  {
    p1=cgetg(li,t_COL); z[j]=(long)p1;
    for (i=1; i<li; i++) p1[i]=(long)algtobasis(nf,gcoeff(x,i,j));
  }
  return z;
}

static GEN
rnfmakematrices(GEN rnf)
{
  long i,j,k,n,r1,r2,ru,ruk,r1rel,r2rel;
  GEN nf,pol,rac,base,base1,r1r2,racnf,sig,vecmat,vecM,vecMC,vecT2,rack;
  GEN M,p2,p3,MC,sigk,T2,T,p1,MD,TI,MDI;

  nf=(GEN)rnf[10]; racnf=(GEN)nf[6]; pol=(GEN)rnf[1];
  n=lgef(pol)-3;
  base=(GEN)rnf[7]; base1=(GEN)base[1]; rac=(GEN)rnf[6]; sig=(GEN)rnf[2];
  r1r2=(GEN)nf[2]; r1=itos((GEN)r1r2[1]); r2=itos((GEN)r1r2[2]); ru=r1+r2;
  vecmat=cgetg(8,t_VEC);
  vecM=cgetg(ru+1,t_VEC); vecmat[1]=(long)vecM;
  vecMC=cgetg(ru+1,t_VEC); vecmat[2]=(long)vecMC;
  vecT2=cgetg(ru+1,t_VEC); vecmat[3]=(long)vecT2;
  for (k=1; k<=ru; k++)
  {
    rack=(GEN)rac[k]; ruk=lg(rack)-1;
    M=cgetg(n+1,t_MAT); vecM[k]=(long)M;
    for (j=1; j<=n; j++)
    {
      p2=cgetg(ruk+1,t_COL); M[j]=(long)p2; p3=lift((GEN)base1[j]);
      p3=gsubst(p3,varn(nf[1]),(GEN)racnf[k]);
      for (i=1; i<=ruk; i++) p2[i]=lsubst(p3,varn(rnf[1]),(GEN)rack[i]);
    }
    MC=gconj(gtrans(M)); vecMC[k]=(long)MC;
    if (k<=r1)
    {
      sigk=(GEN)sig[k]; r1rel=itos((GEN)sigk[1]); r2rel=itos((GEN)sigk[2]);
      if ((r1rel+r2rel)!=(lg(MC)-1)) err(talker,"bug in rnfmakematrices");
      for (j=r1rel+1; j<=r1rel+r2rel; j++) MC[j]=lmul2n((GEN)MC[j],1);
    }
    T2=gmul(MC,M); vecT2[k]=(long)T2;
  }
  T=cgetg(n+1,t_MAT); vecmat[4]=(long)T;
  for (j=1; j<=n; j++)
  {
    p1=cgetg(n+1,t_COL); T[j]=(long)p1;
    for (i=1; i<=n; i++)
      p1[i]=(long)trace(gmodulcp(gmul((GEN)base1[i],(GEN)base1[j]),pol));
  }
  MD=cgetg(1,t_MAT); vecmat[5]=(long)MD; /* matrice de la differente */
  TI=cgetg(1,t_MAT); vecmat[6]=(long)TI; /* matrice .... ? */
  MDI=cgetg(1,t_MAT); vecmat[7]=(long)MDI; /* matrice .... ? */
  return vecmat;
}

GEN
rnfinitalg(GEN nf,GEN pol,long prec)
{
  long av=avma,tetpil,m,n,r1,r2,vnf,i,j,k,vpol,tp1,v1,r1j,r2j,lfac;
  GEN RES,sig,r1r2,rac,p1,p2,liftpol,delta,RAC,ro,p3,bas,baserel,di;
  GEN f,f2,fac,fac1,fac2,om,id,p4,p5;

  if (typ(pol)!=t_POL) err(talker,"not a polynomial in rnfinitalg");
  nf=checknf(nf); n=lgef(pol)-3; vpol=varn(pol);
  vnf=0;
  for (i=0; i<=n; i++)
  {
    p1=(GEN)pol[i+2];
    tp1=typ(p1);
    if (! is_const_t(tp1))
    {
      if (tp1==t_POLMOD)
      {
	if (!gegal((GEN)p1[1],(GEN)nf[1]))
	  err(talker,"incompatible number fields in rnfinitalg");
	p1=(GEN)p1[2];
      }
      if (tp1>10) err(talker,"impossible type in rnfinitalg");
      v1=varn(p1);
      if (!vnf) vnf=v1;
      else if (vnf!=v1) err(talker,"different variables in rnfinitalg");
    }
  }
  if (!vnf) vnf=varn(nf[1]);
  if (vpol>=vnf) 
    err(talker,"main variable must be of higher priority in rnfinitalg");
  RES=cgetg(12,t_VEC);
  RES[1]=(long)pol;
  m=lgef(nf[1])-3;
  r1r2=(GEN)nf[2]; r1=itos((GEN)r1r2[1]); r2=itos((GEN)r1r2[2]);
  sig=cgetg(r1+r2+1,t_VEC); RES[2]=(long)sig;
  rac=(GEN)nf[6]; liftpol=lift(pol);
  RAC=cgetg(r1+r2+1,t_VEC); RES[6]=(long)RAC;
  for (j=1; j<=r1; j++)
  {
    p1=gsubst(liftpol,vnf,(GEN)rac[j]);
    ro=roots(p1,prec);
    r1j=0;
    while ((r1j<n)&&(gcmp0(gimag((GEN)ro[r1j+1])))) r1j++;
    p2=cgetg(3,t_VEC); p2[1]=lstoi(r1j); p2[2]=lstoi(r2j=((n-r1j)>>1));
    sig[j]=(long)p2;
    p3=cgetg(r1j+r2j+1,t_VEC);
    for (i=1; i<=r1j; i++) p3[i]=lreal((GEN)ro[i]);
    for (; i<=r1j+r2j; i++) p3[i]=(long)ro[(i<<1)-r1j];
    RAC[j]=(long)p3;
  }
  for (; j<=r1+r2; j++)
  {
    p2=cgetg(3,t_VEC); p2[1]=zero; p2[2]=lstoi(n); sig[j]=(long)p2;
    p1=gsubst(liftpol,vnf,(GEN)rac[j]);
    RAC[j]=(long)roots(p1,prec);
  }
  p1=rnfpseudobasis(nf,pol);
  delta=cgetg(3,t_VEC); RES[3]=(long)delta; delta[1]=p1[3]; delta[2]=p1[4];
  bas=cgetg(3,t_VEC); RES[7]=(long)bas;
  baserel=(GEN)p1[1];
  p2=matbasistoalg(nf,baserel);
  RES[8]=(long)invmat(p2);
  p3=cgetg(n+1,t_VEC); p3[1]=un;
  for (j=2; j<=n; j++) p3[j]=lmul((GEN)p3[j-1],polx[vpol]);
  bas[1]=lmul(p3,p2); bas[2]=(long)p1[2];
  di=discsr(pol);
  f2=idealdiv(nf,di,(GEN)p1[3]);
  fac=idealfactor(nf,f2);
  fac1=(GEN)fac[1]; fac2=(GEN)fac[2]; lfac=lg(fac1)-1;
  f=idmat(m);
  for (i=1; i<=lfac; i++)
  {
    if (mpodd((GEN)fac2[i]))
      err(talker,"bug: odd exponent in rnfinitalg. Must not happen");
    f=idealmul(nf,f,idealpow(nf,(GEN)fac1[i],gmul2n((GEN)fac2[i],-1)));
  }
  RES[4]=(long)f;
  RES[10]=(long)nf;
  RES[5]=(long)rnfmakematrices(RES);
  RES[9]=lgetg(1,t_VEC); /* table de multiplication */
  p2=cgetg(6,t_VEC); RES[11]=(long)p2;
  p1=rnfequation2(nf,pol); for (i=1; i<=3; i++) p2[i]=p1[i];
  p3=cgetg(n*m+1,t_VEC); p2[4]=(long)p3;
  p4=cgetg(n*m+1,t_MAT);
  for (i=1; i<=n; i++)
  {
    om=rnfelementreltoabs(RES,gmael(bas,1,i));
    id=gmael(bas,2,i);
    for (j=1; j<=m; j++)
    {
      p1=gmul((GEN)nf[7],(GEN)id[j]);
      p3[(i-1)*m+j]=lmul(om,gsubst(p1,varn(nf[1]),(GEN)p2[2]));
      p5=cgetg(n*m+1,t_COL); p4[(i-1)*m+j]=(long)p5;
      p1=lift((GEN)p3[(i-1)*m+j]);
      for (k=0; k<n*m; k++) p5[k+1]=(long)truecoeff(p1,k);
    }
  }
  p2[5]=linvmat(p4);
  tetpil=avma; return gerepile(av,tetpil,gcopy(RES));
}

GEN
rnfbasistoalg(GEN rnf,GEN x)
{
  long tx=typ(x),lx=lg(x),av=avma,tetpil,i,n;
  GEN p1,z,nf;

  checkrnf(rnf); nf=(GEN)rnf[10];
  switch(tx)
  {
    case t_VEC:
      x=gtrans(x); /* fall through */
    case t_COL:
      n=lg(x)-1; p1=cgetg(n+1,t_COL);
      for (i=1; i<=n; i++)
      {
	if (typ(x[i])==t_COL) p1[i]=(long)basistoalg(nf,(GEN)x[i]);
	else p1[i]=x[i];
      }
      p1=gmul(gmael(rnf,7,1),p1); tetpil=avma;
      return gerepile(av,tetpil,gmodulcp(p1,(GEN)rnf[1]));

    case t_MAT:
      z=cgetg(lx,tx);
      for (i=1; i<lx; i++) z[i]=(long)rnfbasistoalg(rnf,(GEN)x[i]);
      return z;

    case t_POLMOD:
      return gcopy(x);

    default:
      z=cgetg(3,t_POLMOD); z[1]=lcopy((GEN)rnf[1]);
      z[2]=lmul(x,polun[varn(rnf[1])]); return z;
  }
}

GEN
rnfalgtobasis(GEN rnf,GEN x)
{
  long av=avma,tetpil,tx=typ(x),lx=lg(x),i,v,N;
  GEN y,z;

  checkrnf(rnf);
  switch(tx)
  {
    case t_VEC: case t_COL: case t_MAT:
      z=cgetg(lx,tx);
      for (i=1; i<lx; i++) z[i]=(long)rnfalgtobasis(rnf,(GEN)x[i]);
      return z;

    case t_POLMOD:
      y=(GEN)x[1]; v=varn(y); setvarn(y,varn(rnf[1]));
      if (!gegal((GEN)rnf[1],y))
	setvarn(y,v); err(talker,"not the same number field in rnfalgtobasis");
      x=(GEN)x[2]; /* fall through */
    case t_POL:
      N=lgef(rnf[1])-3;
      if ((tx==10)&&((lgef(x)-3)>=N)) x=gmod(x,(GEN)rnf[1]);
      z=cgetg(N+1,t_COL); for (i=1; i<=N; i++) z[i]=(long)truecoeff(x,i-1);
      tetpil=avma; return gerepile(av,tetpil,gmul((GEN)rnf[8],z));

    default: N=lgef(rnf[1])-3;
      z=cgetg(N+1,t_COL); z[1]=lcopy(x);
      for (i=2; i<=N; i++) z[i]=zero;
      return z;
  }
}

GEN
rnfelementreltoabs(GEN rnf,GEN x)
{
  long av=avma,tetpil,tx,i,lx;
  GEN z,p1,p2,p3,polabs,teta,alpha,s,k;

  checkrnf(rnf); tx=typ(x); lx=lg(x);
  switch(tx)
  {
    case t_VEC: case t_COL: case t_MAT:
      z=cgetg(lx,tx);
      for (i=1; i<lx; i++) z[i]=(long)rnfelementreltoabs(rnf,(GEN)x[i]);
      return z;

    case t_POLMOD:
      x=(GEN)x[2]; /* fall through */
    case t_POL:
      p1=(GEN)rnf[11]; polabs=(GEN)p1[1]; alpha=(GEN)p1[2]; k=(GEN)p1[3];
      teta=gmodulcp(gsub(polx[varn(rnf[1])],gmul(k,(GEN)alpha[2])),polabs);
      s=gzero;
      for (i=lgef(x)-1; i>1; i--)
      {
	p3=(GEN)x[i];
	switch(typ(p3))
	{
	  case t_POLMOD:
	    p3=(GEN)p3[2]; /* fall through */
	  case t_POL:
	    p2=gsubst(p3,varn(p3),alpha);
	}
	s=gadd(p2,gmul(teta,s));
      }
      tetpil=avma; return gerepile(av,tetpil,gcopy(s));

    default: return gcopy(x);
  }
}

GEN
rnfelementabstorel(GEN rnf,GEN x)
{
  long av=avma,tetpil,tx,i,lx;
  GEN z,p1,s,tetap,k,nf;

  checkrnf(rnf); tx=typ(x); lx=lg(x);
  switch(tx)
  {
    case t_VEC: case t_COL: case t_MAT:
      z=cgetg(lx,tx);
      for (i=1; i<lx; i++) z[i]=(long)rnfelementabstorel(rnf,(GEN)x[i]);
      return z;

    case t_POLMOD:
      x=(GEN)x[2]; /* fall through */
    case t_POL:
      p1=(GEN)rnf[11]; k=(GEN)p1[3]; nf=(GEN)rnf[10];
      tetap=gmodulcp(gadd(polx[varn(rnf[1])],
	    gmul(k,gmodulcp(polx[varn(nf[1])],(GEN)nf[1]))),(GEN)rnf[1]);
      s=gzero;
      for (i=lgef(x)-1; i>1; i--) s=gadd((GEN)x[i],gmul(tetap,s));
      tetpil=avma; return gerepile(av,tetpil,gcopy(s));

    default: return gcopy(x);
  }
}

/* x doit etre un polymod ou un polynome ou un vecteur de tels objets... */
GEN
rnfelementup(GEN rnf,GEN x)
{
  long i,lx,tx;
  GEN z,p1;

  checkrnf(rnf); tx=typ(x); lx=lg(x);
  switch(tx)
  {
    case t_VEC: case t_COL: case t_MAT:
      z=cgetg(lx,tx);
      for (i=1; i<lx; i++) z[i]=(long)rnfelementup(rnf,(GEN)x[i]);
      return z;

    case t_POLMOD:
      x=(GEN)x[2]; /* fall through */
    case t_POL:
      p1=(GEN)rnf[11]; return gsubst(x,varn(x),(GEN)p1[2]);

    default: return gcopy(x);
  }
}

/* x doit etre un polymod ou un polynome ou un vecteur de tels objets..*/
GEN
rnfelementdown(GEN rnf,GEN x)
{
  long av=avma,tetpil,i,lx,tx;
  GEN p1,z;

  checkrnf(rnf); tx=typ(x); lx=lg(x);
  switch(tx)
  {
    case t_VEC: case t_COL: case t_MAT:
      z=cgetg(lx,tx);
      for (i=1; i<lx; i++) z[i]=(long)rnfelementdown(rnf,(GEN)x[i]);
      return z;

    case t_POLMOD:
      x=(GEN)x[2]; /* fall through */
    case t_POL:
      if (gcmp0(x)) return gzero;

      p1=rnfelementabstorel(rnf,x);
      if (typ(p1)==t_POLMOD && varn(p1[1])==varn(rnf[1])) p1=(GEN)p1[2];
      if (gvar(p1)>varn(rnf[1]))
      {
	tetpil=avma;
	return gerepile(av,tetpil,gcopy(p1));
      }
      if (lgef(p1)==3)
      { 
	tetpil=avma; 
        return gerepile(av,tetpil,gcopy((GEN)p1[2]));
      }
      err(talker,"element is not in the base field in rnfelementdown");

    default: return gcopy(x);
  }
}

/* x est exprime sur la base relative */
static GEN
rnfprincipaltohermite(GEN rnf,GEN x)
{
  long av=avma,tetpil;
  GEN nf,bas,bas1,p1,z;

  x=rnfbasistoalg(rnf,x); nf=(GEN)rnf[10];
  bas=(GEN)rnf[7]; bas1=(GEN)bas[1];
  p1=rnfalgtobasis(rnf,gmul(x,gmodulcp(bas1,(GEN)rnf[1]))); 
  z=cgetg(3,t_VEC); z[2]=bas[2];
  settyp(p1,t_MAT); z[1]=(long)matalgtobasis(nf,p1);

  tetpil=avma;
  return gerepile(av,tetpil,nfhermite(nf,z));
}

GEN
rnfidealhermite(GEN rnf,GEN x)
{
  long tx=typ(x),lx=lg(x),av=avma,tetpil,i,j,n,m;
  GEN z,p1,p2,x1,x2,x1j,nf,bas,unnf,zeronf;

  checkrnf(rnf);
  n=lgef(rnf[1])-3; nf=(GEN)rnf[10]; bas=(GEN)rnf[7];

  switch(tx)
  {
    case t_INT: case t_FRAC: case t_FRACN:
      m=lgef(nf[1])-3;
      zeronf=cgetg(m+1,t_COL); for (j=1; j<=m; j++) zeronf[j]=zero;
      unnf=cgetg(m+1,t_COL); unnf[1]=un; for (j=2; j<=m; j++) unnf[j]=zero;
      z=cgetg(3,t_VEC); p1=cgetg(n+1,t_MAT); z[1]=(long)p1;
      for (j=1; j<=n; j++)
      {
	p2=cgetg(n+1,t_COL); p1[j]=(long)p2;
	for (i=1; i<=n; i++) p2[i]=(i==j)?lcopy(unnf):lcopy(zeronf);
      }
      z[2]=lmul(x,(GEN)bas[2]); return z;

    case t_POLMOD: case t_POL:
      p1=rnfalgtobasis(rnf,x); tetpil=avma;
      return gerepile(av,tetpil,rnfidealhermite(rnf,p1));

    case t_VEC:
      switch(lx)
      {
	case 3:
	  x1=(GEN)x[1];
	  if (typ(x1)!=t_MAT || lg(x1)!=(n+1) || lg(x1[1])!=(n+1))
	    err(talker,"incorrect type in rnfidealhermite");
	  p1=cgetg(n+1,t_MAT);
	  for (j=1; j<=n; j++)
	  {
	    p2=cgetg(n+1,t_COL); p1[j]=(long)p2; x1j=(GEN)x1[j];
	    for (i=1; i<=n; i++)
	    {
	      switch(typ(x1j[i]))
	      {
		case t_POLMOD: case t_POL:
		  p2[i]=(long)algtobasis(nf,(GEN)x1j[i]); break;
		case t_COL:
		  p2[i]=x1j[i]; break;
		default: err(talker,"incorrect type in rnfidealhermite");
	      }
	    }
	  }
	  x2=(GEN)x[2];
	  if (typ(x2)!=t_VEC || lg(x2)!=(n+1))
	    err(talker,"incorrect type in rnfidealhermite");
	  tetpil=avma; z=cgetg(3,t_VEC); z[1]=lcopy(p1); z[2]=lcopy(x2);
	  return z;

	case 6:
	  err(impl,"rnfidealhermite for prime ideals");
	default:
	  err(talker,"incorrect type in rnfidealhermite");
      }

    case t_COL:
      if (lx!=(n+1)) err(talker,"incorrect type in rnfidealhermite");
      return rnfprincipaltohermite(rnf,x);

    case t_MAT:
      return rnfidealabstorel(rnf,x);
  }
  err(talker,"incorrect type in rnfidealhermite");
  return NULL; /* not reached */
}

GEN
rnfidealnormrel(GEN rnf,GEN id)
{
  long av=avma,tetpil,i,n,m;
  GEN z,id2,nf;

  checkrnf(rnf);
  id=rnfidealhermite(rnf,id); id2=(GEN)id[2];
  nf=(GEN)rnf[10];
  m=lgef(nf[1])-3; n=lgef(rnf[1])-3;
  z=idmat(m); for (i=1; i<=n; i++) z=idealmul(nf,z,(GEN)id2[i]);
  tetpil=avma; return gerepile(av,tetpil,gcopy(z));
}

GEN
rnfidealnormabs(GEN rnf,GEN id)
{
  long av=avma,tetpil,i,n,m;
  GEN z,id2,nf;

  checkrnf(rnf);
  id=rnfidealhermite(rnf,id); id2=(GEN)id[2];
  nf=(GEN)rnf[10];
  m=lgef(nf[1])-3; n=lgef(rnf[1])-3;
  z=idmat(m); for (i=1; i<=n; i++) z=idealmul(nf,z,(GEN)id2[i]);
  tetpil=avma; return gerepile(av,tetpil,det(z));
}

GEN
rnfidealreltoabs(GEN rnf,GEN x)
{
  long av=avma,tetpil,i,j,k,n,m;
  GEN nf,basinv,om,id,p1,p2,p3,p4,p5;

  checkrnf(rnf);
  x=rnfidealhermite(rnf,x);
  n=lgef(rnf[1])-3; nf=(GEN)rnf[10]; m=lgef(nf[1])-3;
  basinv=(GEN)((GEN)rnf[11])[5];
  p3=cgetg(n*m+1,t_MAT); p2=gmael(rnf,11,2);
  for (i=1; i<=n; i++)
  {
    om=rnfbasistoalg(rnf,gmael(x,1,i)); id=gmael(x,2,i);
    om=rnfelementreltoabs(rnf,om);
    for (j=1; j<=m; j++)
    {
      p1=gmul((GEN)nf[7],(GEN)id[j]);
      p4=lift(gmul(om,gsubst(p1,varn(nf[1]),p2)));
      p5=cgetg(n*m+1,t_COL);
      for (k=0; k<n*m; k++) p5[k+1]=(long)truecoeff(p4,k);
      p3[(i-1)*m+j]=(long)p5;
    }
  }
  p1=gmul(basinv,p3); p2=detint(p1);
  tetpil=avma; return gerepile(av,tetpil,hnfmod(p1,p2));
}

GEN
rnfidealabstorel(GEN rnf,GEN x)
{
  long av=avma,tetpil,n,m,j,k;
  GEN nf,basabs,ma,xj,p1,p2,id;

  checkrnf(rnf); n=lgef(rnf[1])-3; nf=(GEN)rnf[10]; m=lgef(nf[1])-3;
  if (typ(x)!=t_MAT || lg(x)!=(n*m+1) || lg(x[1])!=(n*m+1))
    err(impl,"rnfidealabstorel for an ideal not in HNF");
  basabs=gmael(rnf,11,4); ma=cgetg(n*m+1,t_MAT);
  for (j=1; j<=n*m; j++)
  {
    p2=cgetg(n+1,t_COL); ma[j]=(long)p2;
    xj=gmul(basabs,(GEN)x[j]);
    xj=lift(rnfelementabstorel(rnf,xj));
    for (k=0; k<n; k++)
    {
      p2[k+1]=(long)truecoeff(xj,k);
    }
  }
  ma=gmul((GEN)rnf[8],ma);
  ma=matalgtobasis(nf,ma);
  p1=cgetg(n*m+1,t_VEC); id=idmat(m);
  for (j=1; j<=n*m; j++) p1[j]=(long)id;
  p2=cgetg(3,t_VEC); p2[1]=(long)ma; p2[2]=(long)p1;
  tetpil=avma; return gerepile(av,tetpil,nfhermite(nf,p2));
}

GEN
rnfidealdown(GEN rnf,GEN x)
{
  long av=avma,tetpil;
  GEN p1;

  checkrnf(rnf);
  x=rnfidealhermite(rnf,x);
  p1=gmael(x,2,1);
  tetpil=avma; return gerepile(av,tetpil,gcopy(p1));
}

/* lift ideal x to the relative extension, returns a Z-basis */
GEN
rnfidealup(GEN rnf,GEN x)
{
  long av=avma,tetpil,i,j,n;
  GEN nf,bas,bas1,bas2,p1,p2,p3,p4;

  checkrnf(rnf);
  bas=(GEN)rnf[7]; bas1=(GEN)bas[1]; bas2=(GEN)bas[2];
  n=lg(bas2)-1; nf=(GEN)rnf[10];
  p1=cgetg(n+1,t_VEC);
  for (i=1; i<=n; i++) p1[i]=(long)idealmul(nf,x,(GEN)bas2[i]);
  p2=cgetg(3,t_VEC); p2[2]=(long)p1;
  p3=cgetg(n+1,t_MAT); p2[1]=(long)p3;
  for (j=1; j<=n; j++)
  {
    p4=cgetg(n+1,t_COL); p3[j]=(long)p4;
    for (i=1; i<=n; i++)
      p4[i]=(long)algtobasis(nf,truecoeff((GEN)bas1[j],i-1));
  }
  tetpil=avma; return gerepile(av,tetpil,rnfidealreltoabs(rnf,p2));
}

/* x a relative HNF ---> vector of 2 generators (relative polymods) */
GEN
rnfidealtwoelement(GEN rnf,GEN x)
{
  long av=avma,tetpil,j;
  GEN p1,p2,p3,res,polabs,nfabs,z;

  res=(GEN)rnf[11]; polabs=(GEN)res[1];
  nfabs=cgetg(10,t_VEC); nfabs[1]=(long)polabs;
  for (j=2; j<=9; j++) nfabs[j]=zero;
  nfabs[7]=(long)lift((GEN)res[4]); nfabs[8]=res[5];
  p1=rnfidealreltoabs(rnf,x);
  p2=ideal_two_elt(nfabs,p1);
  p3=rnfelementabstorel(rnf,gmul((GEN)res[4],(GEN)p2[2]));
  tetpil=avma; z=cgetg(3,t_VEC); z[1]=lcopy((GEN)p2[1]);
  z[2]=(long)rnfalgtobasis(rnf,p3);
  return gerepile(av,tetpil,z);
}

GEN
rnfidealmul(GEN rnf,GEN x,GEN y) /* x et y sous HNF relative uniquement */
{
  long av=avma,tetpil,i,j,n;
  GEN z,nf,x1,x2,p1,p2,p3,p4,p5,res;

  z=rnfidealtwoelement(rnf,y);
  nf=(GEN)rnf[10]; n=lgef(rnf[1])-3;
  x=rnfidealhermite(rnf,x);
  x1=gmodulcp(gmul(gmael(rnf,7,1),matbasistoalg(nf,(GEN)x[1])),(GEN) rnf[1]);
  x2=(GEN)x[2]; p1=gmul((GEN)z[1],(GEN)x[1]);
  p2=lift(gmul(rnfbasistoalg(rnf,(GEN)z[2]),x1));
  p3=cgetg(n+1,t_MAT);
  for (j=1; j<=n; j++)
  {
    p4=cgetg(n+1,t_COL); p3[j]=(long)p4; p5=(GEN)p2[j];
    for (i=1; i<=n; i++)
      p4[i]=(long)algtobasis(nf,truecoeff((GEN)p5,i-1));
  }
  res=cgetg(3,t_VEC); res[1]=lconcat(p1,p3); res[2]=lconcat(x2,x2);
  tetpil=avma; return gerepile(av,tetpil,nfhermite(nf,res));
}

/*********************************************************************/
/**                                                                 **/
/**         LIBRARY FOR POLYNOMIALS WITH COEFFS. IN Z_K/P	    **/
/**  An element in Z_K/P is a t_COL with degree(nf[1]) components.  **/
/**  These are integers modulo the prime p under prime ideal P      **/
/**  (only f(P/p) elements are non zero). These components are      **/
/**  given on the integer basis of K.                               **/
/**                                                                 **/
/*********************************************************************/

GEN
polnfmulscal(GEN nf,GEN s,GEN x)
{
  long i,lx=lgef(x);
  GEN z;

  if (lx<3) return gcopy(x);
  if (gcmp0(s))
  { 
    z=cgetg(2,t_POL); z[1]=evallgef(2) | evalvarn(varn(x));
    return z;
  }
  z=cgetg(lx,t_POL); z[1]=x[1];
  for (i=2; i<lx; i++) z[i]=(long)element_mul(nf,s,(GEN)x[i]);
  return z;
}

GEN
polnfmul(GEN nf, GEN x, GEN y)
{
  long av,tetpil,m,i,d,imin,imax,lx,ly,lz;
  GEN p1,z,zeronf;

  if (gcmp0(x)||gcmp0(y))
  { 
    z=cgetg(2,t_POL); z[1]=evallgef(2) | evalvarn(varn(x));
    return z;
  }
  m=lgef(nf[1])-3; av=avma;
  lx=lgef(x)-3; ly=lgef(y)-3; lz=lx+ly;
  zeronf=cgetg(m+1,t_COL);
  for (i=1; i<=m; i++) zeronf[i]=zero;
  z=cgetg(lz+3,t_POL);
  z[1] = evallgef(lz+3) | evalvarn(x) | evalsigne(1);
  for (d=0; d<=lz; d++)
  {
    p1=zeronf; imin=max(0,d-ly); imax=min(d,lx);
    for (i=imin; i<=imax; i++)
      p1=gadd(p1,element_mul(nf,(GEN)x[i+2],(GEN)y[d-i+2]));
    z[d+2]=(long)p1;
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(z));
}

/* division euclidienne */
GEN
polnfdeuc(GEN nf, GEN x, GEN y, GEN *ptr)
{
  long av=avma,m,i,d,tx,lx,ly,lz,fl;
  GEN z,zeronf,unnf,lcy,r;
  GEN *gptr[2];

  m=lgef(nf[1])-3;
  if (gcmp0(x))
  { 
    z=cgetg(2,t_POL); z[1]=evallgef(2) | evalvarn(varn(x));
    return z;
  }
  if (gcmp0(y)) err(talker,"division by zero in polnfdiv");
  lx=lgef(x); ly=lgef(y); lz=lx-ly;
  if (lz<0)
  {
    *ptr=gcopy(x);
    z=cgetg(2,t_POL); z[1]=evallgef(2) | evalvarn(varn(x)); return z;
  }

  zeronf=cgetg(m+1,t_COL);
  for (i=1; i<=m; i++) zeronf[i]=zero;
  unnf=cgetg(m+1,t_COL); unnf[1]=un;
  for (i=2; i<=m; i++) unnf[i]=zero;

  x=gcopy(x); y=gcopy(y);
  for (i=2; i<lx; i++)
  {
    tx=typ(x[i]);
    if (is_intreal_t(tx) || tx == t_INTMOD || is_frac_t(tx))
      x[i]=lmul((GEN)x[i],unnf);
  }

  for (i=2; i<ly; i++)
  {
    tx=typ(y[i]);
    if (is_intreal_t(tx) || tx == t_INTMOD || is_frac_t(tx))
      y[i]=lmul((GEN)y[i],unnf);
  }

  lz+=3;
  z=cgetg(lz,t_POL); z[1]=evallgef(lz) | evalvarn(x) | evalsigne(1);
  lcy=(GEN)y[ly-1];
  if (gegal(lift(lcy),unnf)) fl=0;
  else
  {
    fl=1; y=polnfmulscal(nf,element_inv(nf,lcy),y);
  }
  for (d=lz-1; d>=2; d--)
  {
    z[d]=x[d+ly-3];
    for (i=d; i<d+ly-3; i++)
      x[i]=lsub((GEN)x[i],element_mul(nf,(GEN)z[d],(GEN)y[i-d-2]));
  }
  if (fl) z=polnfmulscal(nf,lcy,z);

  for(;;)
  {
    if (!gcmp0((GEN)x[d]))
    {
      r=cgetg(d,t_POL);
      r[1] = evallgef(d) | evalvarn(varn(x)) | evalsigne(1);
      for (i=2; i<d; i++) r[i]=x[i];
      break;
    }
    if (d==2)
    { 
      r=cgetg(2,t_POL);
      r[1] = evallgef(2) | evalvarn(varn(x));
      break;
    }
    d--;
  }

  *ptr=r; gptr[0]=ptr; gptr[1]=&z;
  gerepilemany(av,gptr,2); return z;
}

GEN
polnfpow(GEN nf,GEN x,GEN k)
{
  long i,s,av=avma,tetpil,m;
  GEN k1,y,z,unnf;

  m=lgef(nf[1])-3;
  if (typ(k)!=t_INT) err(talker,"not an integer exponent in nfpow");
  s=signe(k); k1 = (s>=0) ? k : negi(k); z=x;
  if (s<0) err(impl,"polnfpow for negative exponents");

  y=cgetg(3,t_POL); unnf=cgetg(m+1,t_COL); y[2]=(long)unnf;
  y[1] = evallgef(3) | evalvarn(varn(x)) | evalsigne(1);
  for (i=2; i<=m; i++) unnf[i]=zero; unnf[1]=un;
  for(;;)
  {
    if (mpodd(k1)) y=polnfmul(nf,z,y);
    k1=shifti(k1,-1);
    if (signe(k)) z=polnfmul(nf,z,z);
    else break;
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(y));
}

#if 0
/* factor polynomial f (with coeffs in nf) modulo the prime ideal pr */
GEN
nffactmodp2(GEN nf, GEN f, GEN pr)
{
  long i,j,k,d,e,vf,va,expos[100],psim,nbfact,nbf,av=avma,pk,tetpil,calc;
  long degp,m;
  GEN y,t[100],f1,f2,f3,df1,df2,g,g1,g2;
  GEN xmod,u,v,pd,q,qq,unfp,unfq,p,prh,a;

  if (typ(f)!=t_POL || gcmp0(f)) err(factmoder);
  if (typ(pr)!=t_VEC || lg(pr)!=6)
    err(talker,"not a prime ideal in nffactmodp2");
  if (lgef(f)==3)
  { 
    y=cgetg(3,t_MAT); y[1]=lgetg(1,t_COL);
    y[2]=lgetg(1,t_COL); return y;
  }
  vf=varn(f); va=varn(nf[1]);
  if (va<=vf)
    err(talker,"polynomial variable must be of higher priority than number field variable\nin nffactmodp2");
  p=(GEN)pr[1]; degp=itos((GEN)pr[4]); qq=gpuigs(p,degp);
  unfp=gmodulcp(gun,p); m=lgef(nf[1])-3;
  prh=idealhermite(nf,pr);

 /* 1ere etape :
  *  trouver les facteurs square-free produit des facteurs premiers de meme
  *  multiplicite
  */
  f1=f; e=0; nbfact=1; pk=1; df1=deriv(f1,vf); calc=0;
  do
  {
    e+=pk;
    while (gcmp0(df1))
    {
      pk *= (psim=itos(p)); e=pk;
      j=(lgef(f1)-3)/psim+3; f2=cgetg(j,t_POL);
      f2[1]=evalsigne(1)+evallgef(j); setvarn(f2,vf);
      for (i=2; i<j; i++)
	f2[i]=lcopy((GEN)f1[psim*(i-2)+2]);
      f1=f2; df1=deriv(f1,vf); calc=0;
    }
    if (calc) f2=f3; else f2=ggcd(f1,df1);
    calc=1;
    if (lgef(f2)<4) u=f1;
    else
    {
      g1=gdiv(f1,f2); df2=deriv(f2,vf);
      if (gcmp0(deriv(f2,vf)))
      {
	u=g1; f3=f2;
      }
      else
      {
	f3=ggcd(f2,df2);
	if (lgef(f3)<4) u=gdiv(g1,f2);
	else
	{
	  g2=gdiv(f2,f3); u=gdiv(g1,g2);
	}
      }
    }

   /*  2eme etape :
    *    Ici u est un polynome square-free (produit des facteurs premiers de
    *    meme multiplicite  e : trouver les facteurs (square-free) produit
    *    des facteurs de meme degre d
    */

    d=0; pd=gun;
    xmod=gmodulcp(polx[vf],u); v=xmod;
    while (d<(lgef(u)-3)>>1)
    {
      d++; pd=mulii(pd,qq);
      q=shifti(subis(pd,1),-1);
      v=gpui(v,qq,0);
      g=ggcd((GEN)(gsub(v,xmod))[2],u);
      if (lgef(g)>3)
      {
       /*  3eme etape : g est produit de pol irreductibles de degre d; */
	t[nbfact]=g; j=nbfact+(lgef(g)-3)/d;
	splitzk(qq,t+nbfact,d,p[2],q,unfq,qq,a);

       /* le premier parametre est un entier variable m qui sera converti en
	* un polynome w dont les coeff sont ses digits en base p
	* (initialement m = p --> X) pour faire pgcd de g avec w^(qq^d-1)/2
	* jusqu'a casser.
	*/
	for (; nbfact<j; expos[nbfact++]=e);
	u=gdiv(u,g); v=gmodulcp((GEN)v[2],u);
      }
    }
    if (lgef(u)>3) { t[nbfact]=u; expos[nbfact++]=e; }
    f1=f2; df1=df2;
  }
  while (lgef(f1)>3);

  nbf=nbfact; tetpil=avma;
  t[1]=gdiv((GEN)t[1],gmael(t,1,lgef(t[1])-1));
  for (j=2; j<nbfact; j++)
  {
    if (expos[j]) t[j]=gdiv((GEN)t[j],gmael(t,j,lgef(t[j])-1));
    for (k=1; k<j; k++)
      if (expos[k] && polegal(t[j],t[k]))
      { 
	expos[k]+=expos[j]; expos[j]=0;
	nbf--; k=j;
      }
  }
  y=cgetg(3,t_MAT);
  u=cgetg(nbf,t_COL); y[1]=(long)u;
  v=cgetg(nbf,t_COL); y[2]=(long)v;
  for (j=1,k=0; j<nbfact; j++)
  {
    if (expos[j])
    {
      k++;
      u[k]=(long)t[j];
      v[k]=lstoi(expos[j]);
    }
  }
  return gerepile(av,tetpil,y);
}

/* returns a polynomial (var v), whose coeffs are the digits of m (base qq) */
static GEN
stopolyzk(GEN m, long p, GEN qq, long v, GEN a)
{
  GEN y,p1,p2,r,c[1000],d[1000];
  long l=2,l1,i,j,va=varn(a);

  do
  {
    m=dvmdii(m,qq,&r);
    c[l++]=r;
  }
  while (signe(m));
  y=cgetg(l,t_POL); y[1]=evalsigne(1) | evallgef(l);
  setvarn(y,v);
  for (i=2; i<l; i++)
  {
    p1=c[i]; l1=2;
    do
    {
      p1=dvmdis(p1,p,&r);
      d[l1++]=r;
    }
    while (signe(p1));
    p2=cgetg(l1,t_POL); p2[1]=evalsigne(1) | evallgef(l1);
    setvarn(p2,va);
    for (j=2; j<l1; j++) p2[j]=(long)d[j];
    y[i]=lmodulcp(p2,a);
  }
  return y;
}

/* returns a random polynomial (var v) whose degree is <= 2*d1-1 */
static GEN
stopolyzk2(long d1, long v, GEN a, GEN *ptres)
{
  GEN y,p2;
  long p1,l1,i,j,d2,l,va=varn(a),c[1000],d[1000],k=lgef(a)-3,nsh;

  c[1]=1; d2=d1+d1+1;
  nsh=BITS_IN_RANDOM-1-k; if (nsh<=0) nsh=1;
  do
  {
    for (l=2; l<=d2; l++) c[l]=(mymyrand())>>nsh;
    l=d2; while (!c[l]) l--;
  }
  while (l<=2);
  l++;
  y=cgetg(l,t_POL); y[1]=evalsigne(1)+evallgef(l); setvarn(y,v);
  for (i=2; i<l; i++)
  {
    p1=c[i]; l1=2;
    do { d[l1++]=p1&1; p1>>=1; } while (p1);
    p2=cgetg(l1,t_POL); p2[1]=evalsigne(1)+evallgef(l1); setvarn(p2,va);
    for (j=2; j<l1; j++) p2[j]=lstoi(d[j]);
    y[i]=lmodulcp(p2,a);
  }
  p1=(mymyrand())>>nsh; l1=2;
  do { d[l1++]=p1&1; p1>>=1; } while (p1);
  p2=cgetg(l1,t_POL); p2[1]=evalsigne(1)+evallgef(l1); setvarn(p2,va);
  for (j=2; j<l1; j++) p2[j]=lstoi(d[j]);
  *ptres=gmodulcp(p2,a);
  return y;
}

/*-----------------------------------------------------
   Programme recursif :
  Entree:
   m entier arbitraire ( converti en un polynome w )
   p nb premier; q=(qq^d-1)/2
   t[0] polynome de degre k*d prod de k fact de deg d.
  Sortie:
   t[0],t[1]...t[k-1] contiennent les k facteurs de g
------------------------------------------------------*/
static void
splitzk(GEN m, GEN *t, long d, long p, GEN q, GEN unfq, GEN qq, GEN a)
{
  long j,l,v,av,av2,lim,dv;
  GEN w,w0,wm,res;

  if ((dv=lgef(*t)-3)==d) return;
  v=varn(*t); lim=(bot+avma)>>1;
  do
  {
    av=avma;
    if (p==2)
    {
      w=gmul(stopolyzk2(d,v,a,&res),unfq);
      for (w0=w,j=1; j<d; j++) w=gmod(gadd(w0,gpui(w,qq,0)),*t);
      w=gsub(w,res);
    }
    else
    {
      w=gmul(stopolyzk(m,p,qq,v,a),unfq); m=addsi(1,m);
      wm=gpui(gmodulcp(w,*t),q,0); w=gsub((GEN)wm[2],unfq);
    }
    av2=avma; w=ggcd(*t,w); l=lgef(w)-3;
    if (avma<lim)
    {
      GEN *gptr[2];

      m=gcopy(m); gptr[0]=&m; gptr[1]=&w;
      gerepilemanysp(av,av2,gptr,2);
    }
  }
  while ((!l)||(l==dv));
  t[j=l/d]=gdiv(*t,w); *t=w;
  splitzk(m,t+j,d,p,q,unfq,qq,a); splitzk(m,t,d,p,q,unfq,qq,a);
}
#endif
