/*******************************************************************/
/*******************************************************************/
/*                                                                 */
/*                       RAY CLASS FIELDS                          */
/*                                                                 */
/*******************************************************************/
/*******************************************************************/
/* $Id: buch3.c,v 1.914.7.1 1997/01/19 16:18:09 karim Exp karim $ */

#include "genpari.h"
GEN compute_class_number(GEN mit,GEN *met,GEN *u1,GEN *u2);
GEN compute_prhall(GEN nf,GEN pr);
GEN logunitmatrix(GEN nf,GEN funits,GEN racunit,GEN bid);
GEN vconcat(GEN Q1, GEN Q2);

static GEN idealmodidele(GEN nf, GEN z, GEN module, GEN structarch, GEN arch, long nba, long prec);

static GEN idealmulmodidele(GEN nf, GEN x, GEN y, GEN module, GEN structarch, GEN arch, long nba, long prec);

static GEN idealpowmodidele(GEN nf,GEN x,GEN k,GEN module, GEN structarch, GEN arch, long nba, long prec);

GEN
buchnarrow(GEN bignf)
{
  GEN nf,dataclassgroup,zeromod2,unmod2,rac,cyclic,generator,v,matsign,genplus;
  GEN dataunit,p1,p2,p3,p4,h,v2,vecsign,clh,basecl,met,u1,u2,mot,v3,alpha,bas,lambda;
  long R1,R,i,j,va,ngen,sizeh,t,lo,c,s,av=avma,tetpil,N,fl,r,rr,rankinit,ranknew,k,limr;
  long av1,kk;

  if (typ(bignf)!=t_VEC || lg(bignf)!=11)
    err(talker,"not a big number field vector in buchnarrow");
  nf=(GEN)bignf[7];
  if (typ(nf)!=t_VEC || lg(nf)<10) err(idealer1);
  R1=itos(gmael(nf,2,1)); if (!R1) return gcopy(gmael(bignf,8,1));

  N=lgef(nf[1])-3;
  unmod2=gmodulcp(gun,gdeux); zeromod2=gmodulcp(gzero,gdeux);
  va=varn(nf[1]); rac=(GEN)nf[6];
  dataclassgroup=(GEN)((GEN)bignf[8])[1];
  cyclic=(GEN)dataclassgroup[2]; generator=(GEN)dataclassgroup[3];
  ngen=lg(cyclic)-1;
  v=cgetg(R1+1,t_COL); for (i=1; i<=R1; i++) v[i]=(long)unmod2;
  matsign=signunit(bignf); R=lg(matsign);
  dataunit=cgetg(R+1,t_MAT);
  for (j=1; j<R; j++)
  {
    p1=cgetg(R1+1,t_COL); dataunit[j]=(long)p1;
    for (i=1; i<=R1; i++)
    { p1[i]=(signe(gcoeff(matsign,i,j))>0)? (long)zeromod2:(long)unmod2; }
  }
  dataunit[R]=(long)v;
  v2=image(dataunit); t=lg(v2)-1;
  vecsign=cgetg(R1+1,t_COL); sizeh=ngen+R1-t;
  genplus=cgetg(sizeh+1,t_COL);
  for (i=1; i<=ngen; i++) genplus[i]=generator[i];
  r=1; rr=3; bas=(GEN)nf[7]; rankinit=t; j=ngen; fl=(t<R1);
  lambda=cgeti(N+1);
  while (fl)
  {
    limr=(itos(gmin(stoi(BIGINT),gpuigs(stoi(rr),N)))-1)>>1;
    for (k=rr; (k<=limr)&&fl; k++)
    {
      kk=k; for (i=1; i<=N; i++){ lambda[i]=(kk+r)%rr-r; kk/=rr; }
      av1=avma;
      alpha=gzero;
      for (i=1; i<=N; i++)
	alpha=gadd(alpha,gmulsg(lambda[i],(GEN)bas[i]));
      for (i=1; i<=R1; i++)
	vecsign[i]=(signe(gsubst(alpha,va,(GEN)rac[i]))>0)?(long)zeromod2:(long)unmod2;
      v3=concat(v2,gtomat(vecsign)); ranknew=rank(v3);
      if (ranknew>rankinit)
      {
	v2=v3; rankinit++; fl=(rankinit<R1); j++; genplus[j]=(long)alpha;
      }
      else avma=av1;
    }
    if (fl){ r++; rr+=2; }
  }
  generator=genplus;
  v=ginv(v2);
  h=cgetg(sizeh+1,t_MAT);
  for (j=1; j<=ngen; j++)
  {
    p1=cgetg(sizeh+1,t_COL); h[j]=(long)p1;
    p4=(GEN)cyclic[j];
    p2=(GEN)generator[j];
    p3=gmul((GEN)nf[7],(GEN)isprincipalall(bignf,idealpow(nf,p2,p4),3)[2]);
    for (i=1; i<=R1; i++)
      vecsign[i]=(signe(gsubst(p3,va,(GEN)rac[i]))>0)?(long)zeromod2:(long)unmod2;
    p3=gmul(v,vecsign);
    for (i=1; i<=ngen; i++) p1[i]=(i==j)?cyclic[j]:zero;
    for (i=ngen+1; i<=sizeh; i++) p1[i]=(long)lift((GEN)p3[i+t-ngen]);
  }
  for (j=ngen+1; j<=sizeh; j++)
  {
    p1=cgetg(sizeh+1,t_COL); h[j]=(long)p1;
    for (i=1; i<=sizeh; i++) p1[i]=(i==j)?deux:zero;
  }
  clh=compute_class_number(h,&met,&u1,&u2);
  u1=reducemodmatrix(u1,h);
  lo=lg(met)-1; c=0;
  for (i=1; i<=lo; i++)
    if (!gcmp1(gcoeff(met,i,i))) c++; basecl=cgetg(c+1,t_VEC);
  for (j=1; j<=c; j++)
  {
    p3=(GEN)idealpow(nf,(GEN)generator[1],p1=gcoeff(u1,1,j));
    if (signe(p1)<0) p3=numer(p3);
    for (i=2; i<=lo; i++)
    {
      p1=gcoeff(u1,i,j); s=signe(p1);
      if (s)
      {
	p3=idealmul(nf,p3,(GEN)idealpow(nf,(GEN)generator[i],p1));
	p3=gdiv(p3,content(p3));
      }
    }
    basecl[j]=(long)p3;
  }
  tetpil=avma; p1=cgetg(4,t_VEC); p1[1]=lcopy(clh);
  mot=cgetg(c+1,t_VEC);
  for (i=1; i<=c; i++) mot[i]=lcopy(gcoeff(met,i,i));
  p1[2]=(long)mot; p1[3]=lcopy(basecl);
  return gerepile(av,tetpil,p1);
}

static GEN
buchrayall(GEN bignf,GEN ideal,long flun,long prec)
/* si flun=1 buchray , si flun=-1 buchrayinitgen , si flun=0 buchrayinit */
{
  GEN nf,dataclassgroup,cyclic,generator,genplus;
  GEN dataunit,p1,p2,p3,p4,p5,h,clh,basecl,met,u1,u2,u1inv,mot;
  GEN racunit,bigres,bid,resbid,resbid2,resbid3,x,y,funits,hmat,vecel;
  GEN fa2,structarch,arch,module,hmatu,u,clg;
  long R1,R,R3,i,j,ngen,sizeh,lo,c,s,av=avma,tetpil,N,nba;

  checkbnf(bignf);
  nf=(GEN)bignf[7]; bigres=(GEN)bignf[8];
  if (typ(nf)!=t_VEC || lg(nf)<10) err(idealer1);
  if (lg(bigres)!=5)
  {
    if (lg(bigres)!=7) err(talker,"incorrect big number field in buchray");
    else funits=(GEN)bigres[5];
  }
  else funits=(GEN)buchfu(bignf)[1];
  dataclassgroup=(GEN)bigres[1];
  cyclic=(GEN)dataclassgroup[2]; generator=(GEN)dataclassgroup[3];
  ngen=lg(cyclic)-1;
  R1=itos((GEN)((GEN)nf[2])[1]); N=lgef(nf[1])-3;
  bid=zidealstarinitall(nf,ideal,1);
  module=(GEN)bid[1]; arch=(GEN)module[2];
  for (nba=0,i=1; i<lg(arch); i++) if (signe(arch[i])) nba++;
  if (typ(ideal)==t_VEC && lg(ideal)==3) x=(GEN)ideal[1]; else x=ideal;
  x=idealhermite(nf,x);
  resbid=(GEN)bid[2]; resbid2=(GEN)resbid[2]; resbid3=(GEN)resbid[3];
  fa2=(GEN)bid[4]; structarch=(GEN)fa2[lg(fa2)-1];
  R3=lg(resbid2)-1;
  if (!R3)
  {
    genplus=cgetg(ngen+1,t_VEC); vecel=cgetg(ngen+1,t_VEC);
    for (j=1; j<=ngen; j++)
    {
      p4=(GEN)cyclic[j]; p2=(GEN)generator[j];
      vecel[j]=(long)idealcoprime(nf,p2,x);
      p3=idealmul(nf,(GEN)vecel[j],p2); genplus[j]=(long)p3;
    }
    tetpil=avma;
    if (flun)
    {
      p1=cgetg(4,t_VEC); p1[1]=lcopy((GEN)dataclassgroup[1]);
      p1[2]=lcopy(cyclic); p1[3]=lcopy(genplus);
    }
    else
    {
      p1=cgetg(3,t_VEC); p1[1]=lcopy((GEN)dataclassgroup[1]);
      p1[2]=lcopy(cyclic);
    }
    if (flun>0) return gerepile(av,tetpil,p1);
    y=cgetg(7,t_VEC); y[1]=lcopy(bignf); y[2]=lcopy(bid); y[3]=lcopy(vecel);
    y[4]=(long)idmat(ngen); y[5]=(long)p1;
    p2=cgetg(3,t_VEC); p2[1]=lgetg(1,t_MAT); p2[2]=(long)idmat(lg(funits));
    y[6]=(long)p2;
    return gerepile(av,tetpil,y);
  }
  R=lg(funits);
  if (R!=((N+R1)>>1)) err(talker,"incorrect unit length in buchray");
  racunit=(GEN)((GEN)bigres[4])[2]; dataunit=cgetg(R+R3+1,t_MAT);
  dataunit[1]=(long)zideallog(nf,racunit,bid);
  for (j=2; j<=R; j++) dataunit[j]=(long)zideallog(nf,(GEN)funits[j-1],bid);
  for (j=R+1; j<=R+R3; j++)
  {
    p1=cgetg(R3+1,t_COL); dataunit[j]=(long)p1;
    for (i=1; i<=R3; i++) p1[i]=(i==(j-R))?resbid2[i]:zero;
  }
  hmatu=hnfall(dataunit); hmat=(GEN)hmatu[1];
/*  hmat=hnfmod(dataunit,(GEN)resbid[1]); */
  sizeh=ngen+R3; h=cgetg(sizeh+1,t_MAT);
  genplus=cgetg(sizeh+1,t_VEC);
  vecel=cgetg(ngen+1,t_VEC);
  for (j=1; j<=ngen; j++)
  {
    p1=cgetg(sizeh+1,t_COL); h[j]=(long)p1;
    p4=(GEN)cyclic[j]; p2=(GEN)generator[j];
    vecel[j]=(long)idealcoprime(nf,p2,x);
    p3=idealmul(nf,(GEN)vecel[j],p2); genplus[j]=(long)p3;
    p5=(GEN)isprincipalall(bignf,idealpow(nf,p2,p4),3)[2];
    p5=element_mul(nf,p5,element_pow(nf,(GEN)vecel[j],p4));
    p2=zideallog(nf,p5,bid);
    for (i=1; i<=ngen; i++) p1[i]=(i==j)?cyclic[j]:zero;
    for (i=ngen+1; i<=sizeh; i++) p1[i]=lnegi((GEN)p2[i-ngen]);
  }
  for (j=ngen+1; j<=sizeh; j++)
  {
    p1=cgetg(sizeh+1,t_COL); h[j]=(long)p1;
    for (i=1; i<=ngen; i++) p1[i]=zero;
    for (i=ngen+1; i<=sizeh; i++) p1[i]=coeff(hmat,i-ngen,j-ngen);
    genplus[j]=resbid3[j-ngen];
  }
  generator=genplus;
  clh=compute_class_number(h,&met,&u1,&u2);
  lo=lg(met)-1;
  c=0; for (i=1; i<=lo; i++) if (!gcmp1(gcoeff(met,i,i))) c++;
  u1inv=ginv(u1);
  if (flun)
  {
    u1=reducemodmatrix(u1,h); basecl=cgetg(c+1,t_VEC);
    for (j=1; j<=c; j++)
    {
      p3=idmat(N); p4=p3;
      for (i=1; i<=lo; i++)
      {
	p1=gcoeff(u1,i,j); s=signe(p1);
	if (s)
	{
	  if (s>0) p3=idealmulmodidele(nf,p3,(GEN)idealpowmodidele(nf,(GEN)generator[i],p1,module,structarch,arch,nba,prec),module,structarch,arch,nba,prec);
	  else p4=idealmulmodidele(nf,p4,(GEN)idealpowmodidele(nf,(GEN)generator[i],negi(p1),module,structarch,arch,nba,prec),module,structarch,arch,nba,prec);
	}
      }
      p5=(GEN)ideleaddone(nf,p4,ideal)[1];
      p1=idealdivexact(nf,idealmul(nf,p5,p3),p4);
      basecl[j]=(long)idealmodidele(nf,p1,module,structarch,arch,nba,prec);
    }
    tetpil=avma; clg=cgetg(4,t_VEC); clg[1]=lcopy(clh);
    mot=cgetg(c+1,t_VEC); for (i=1; i<=c; i++) mot[i]=lcopy(gcoeff(met,i,i));
    clg[2]=(long)mot; clg[3]=lcopy(basecl);
  }
  else
  {
    tetpil=avma; clg=cgetg(3,t_VEC); clg[1]=lcopy(clh);
    mot=cgetg(c+1,t_VEC); for (i=1; i<=c; i++) mot[i]=lcopy(gcoeff(met,i,i));
    clg[2]=(long)mot;
  }
  if (flun>0) return gerepile(av,tetpil,clg);
  u=(GEN)hmatu[2]; u2=cgetg(R3+1,t_MAT);
  for (j=1; j<=R3; j++)
  {
    p1=cgetg(R+1,t_COL); u2[j]=(long)p1; p2=(GEN)u[j+R];
    for (i=1; i<=R; i++) p1[i]=p2[i];
  }
  p3=gmul(u2,ginv(hmat));
  u1=cgetg(R+1,t_MAT);
  for (j=1; j<=R; j++)
  {
    p1=cgetg(R+1,t_COL); u1[j]=(long)p1; p2=(GEN)u[j];
    for (i=1; i<=R; i++) p1[i]=p2[i];
  }
  p1=lllint(u1);
  tetpil=avma;
  y=cgetg(7,t_VEC); y[1]=lcopy(bignf); y[2]=lcopy(bid); y[3]=lcopy(vecel);
  y[4]=lcopy(u1inv); y[5]=lcopy(clg); p2=cgetg(3,t_VEC); p2[1]=lcopy(p3);
  p2[2]=lmul(u1,p1); y[6]=(long)p2;
  return gerepile(av,tetpil,y);
}

GEN
buchrayinitgen(GEN bignf, GEN ideal,long prec)
{
  return buchrayall(bignf,ideal,-1,prec);
}

GEN
buchrayinit(GEN bignf, GEN ideal,long prec)
{
  return buchrayall(bignf,ideal,0,prec);
}

GEN
buchray(GEN bignf, GEN ideal,long prec)
{
  return buchrayall(bignf,ideal,1,prec);
}

GEN
buchray0(GEN bignf, GEN ideal, long flag, long prec)
{
  return buchrayall(bignf,ideal,1-flag,prec);
}

GEN
initbuchray(GEN bignf, GEN ideal, long flag, long prec)
{
  switch(flag)
  {
    case 0:
    case 1: return buchrayall(bignf,ideal,-flag,prec);
  }
  err(flagerr);
  return NULL; /* not reached */
}

GEN
rayclassno(GEN bignf,GEN ideal)
{
  GEN nf,dataclassgroup,dataunit,p1;
  GEN racunit,bigres,bid,resbid,resbid2,funits,hmat;
  long R,R3,i,j,av=avma,tetpil;

  checkbnf(bignf);
  nf=(GEN)bignf[7]; bigres=(GEN)bignf[8];
  if (typ(nf)!=t_VEC || lg(nf)<10) err(idealer1);
  if (lg(bigres)!=5)
  {
    if (lg(bigres)!=7) err(talker,"incorrect big number field in rayclass");
    else funits=(GEN)bigres[5];
  }
  else funits=(GEN)buchfu(bignf)[1];
  dataclassgroup=(GEN)bigres[1];
  bid=zidealstarinitall(nf,ideal,0);
  resbid=(GEN)bid[2]; resbid2=(GEN)resbid[2];
  R3=lg(resbid2)-1;
  if (!R3) { avma=av; return gcopy((GEN)dataclassgroup[1]); }

  R=lg(funits); racunit=gmael(bigres,4,2); dataunit=cgetg(R+R3+1,t_MAT);
  dataunit[1]=(long)zideallog(nf,racunit,bid);
  for (j=2; j<=R; j++) dataunit[j]=(long)zideallog(nf,(GEN)funits[j-1],bid);
  for (j=R+1; j<=R+R3; j++)
  {
    p1=cgetg(R3+1,t_COL); dataunit[j]=(long)p1;
    for (i=1; i<=R3; i++) p1[i]=(i==(j-R))?resbid2[i]:zero;
  }
  hmat=hnfmod(dataunit,(GEN)resbid[1]);
  p1=det(hmat); tetpil=avma;
  return gerepile(av,tetpil,gmul(p1,(GEN)dataclassgroup[1]));
}

GEN
isprincipalrayall(GEN bignfray, GEN x, long flall)
{
  long av=avma,tetpil,i,j,c,N,ngen,ngzk;
  GEN bnf,nf,bid,vecel,vecep,matu,ep,p1,p2,p3,p4,beta,idep,y,rayclass;
  GEN divray,genray,alpha,alphaall,racunit,res,funit,pol;

  checkbnr(bignfray);
  bnf=(GEN)bignfray[1]; bid=(GEN)bignfray[2];
  vecel=(GEN)bignfray[3]; matu=(GEN)bignfray[4];
  rayclass=(GEN)bignfray[5]; nf=(GEN)bnf[7]; ngen=lg(vecel)-1;
  idep=isprincipalall(bnf,x,3);
  if (lg(idep[1])!=(ngen+1))
    err(talker,"incorrect generator length in isprincipalray");
  pol=(GEN)nf[1]; N=lgef(pol)-3;
  p2=cgetg(N+1,t_COL); p2[1]=un;
  for (i=2; i<=N; i++) p2[i]=zero;
  ep=(GEN)idep[1];
  for (i=1; i<=ngen; i++)
    if (typ(vecel[i]) != t_INT)
      p2=element_mul(nf,p2,element_pow(nf,(GEN)vecel[i],(GEN)ep[i]));
  beta=element_div(nf,(GEN)idep[2],p2);
  p3=zideallog(nf,beta,bid); ngzk=lg(p3)-1;
  vecep=cgetg(ngen+ngzk+1,t_COL);
  for (i=1; i<=ngen; i++) vecep[i]=ep[i];
  for ( ; i<=ngen+ngzk; i++) vecep[i]=p3[i-ngen];
  p1=gmul(matu,vecep);
  divray=(GEN)rayclass[2]; c=lg(divray)-1;
  tetpil=avma; y=cgetg(c+1,t_COL);
  for (i=1; i<=c; i++) y[i]=(long)modii((GEN)p1[i],(GEN)divray[i]);
  if (!flall) return gerepile(av,tetpil,y);

  if (lg(rayclass)<=3)
    err(talker,"please apply buchrayinitgen and not buchrayinit");
  genray=(GEN)rayclass[3]; p1=idmat(N);
  for (i=1; i<=c; i++)
    p1=idealmul(nf,idealpow(nf,(GEN)genray[i],(GEN)y[i]),p1);
  alphaall=isprincipalall(bnf,idealdiv(nf,x,p1),3);
  if (!gcmp0((GEN)alphaall[1]))
    err(talker,"bug1 in isprincipalray, please report");
  p3=zideallog(nf,(GEN)alphaall[2],bid);
  p4=(GEN)bignfray[6]; p3=gmul((GEN)p4[1],p3);
  if (!gcmp1(denom(p3))) err(talker,"bug2 in isprincipalray, please report");
  x=lllreducemodmatrix(p3,(GEN)p4[2]);
/*    x=gaussmodulo((GEN)bignfray[6],(GEN)bid2[2],p3); */
  if (x==gzero) err(talker,"bug2 in isprincipalray, please report");
  res=(GEN)bnf[8];
  racunit=(GEN)res[4]; funit=(GEN)res[5];
  p3=gpui(gmodulcp((GEN)racunit[2],pol),(GEN)x[1],0);
  for (j=1; j<lg(funit); j++)
    p3=gmul(p3,gpui(gmodulcp((GEN)funit[j],pol),(GEN)x[j+1],0));
  alpha=gdiv(basistoalg(nf,(GEN)alphaall[2]),p3);
  tetpil=avma;
  p1=cgetg(4,t_VEC); p1[1]=lcopy(y); p1[2]=(long)algtobasis(nf,alpha);
  p1[3]=(long)gmin((GEN)idep[3],(GEN)alphaall[3]);
  return gerepile(av,tetpil,p1);
}

GEN
isprincipalray(GEN bignfray, GEN x)
{
  return isprincipalrayall(bignfray,x,0);
}

GEN
isprincipalraygen(GEN bignfray, GEN x)
{
  return isprincipalrayall(bignfray,x,1);
}

static GEN
computezimmertbound(long N,long R1,GEN DK) /* DK = |dK|; give c[N][R1] */
{
  long av,tetpil,i,R2;
  double **c;
  GEN w,p1,minkowskibound;

  if (N<2) return gun;
  if (N<21)
  {
    av=avma;
    c=(double**)xmalloc(sizeof(double*)*21);
    for (i=1; i<=20; i++) c[i]=(double*)xmalloc(sizeof(double)*21);
    c[2][2]=-0.6931;       c[2][0]=-0.45158;      c[3][3]=-1.71733859;
    c[3][1]=-1.37420604;   c[4][4]=-2.91799837;   c[4][2]=-2.50091538;
    c[4][0]=-2.11943331;   c[5][5]=-4.22701425;   c[5][3]=-3.75471588;
    c[5][1]=-3.31196660;   c[6][6]=-5.61209925;   c[6][4]=-5.09730381;
    c[6][2]=-4.60693851;   c[6][0]=-4.14303665;   c[7][7]=-7.05406203;
    c[7][5]=-6.50550021;   c[7][3]=-5.97735406;   c[7][1]=-5.47145968;
    c[8][8]=-8.54052636;   c[8][6]=-7.96438858;   c[8][4]=-7.40555445;
    c[8][2]=-6.86558259;   c[8][0]=-6.34608077;   c[9][9]=-10.0630022;
    c[9][7]=-9.46382812;   c[9][5]=-8.87952524;   c[9][3]=-8.31139202;
    c[9][1]=-7.76081149;   c[10][10]=-11.6153797; c[10][8]=-10.9966020;
    c[10][6]=-10.3907654;  c[10][4]=-9.79895170;  c[10][2]=-9.22232770;
    c[10][0]=-8.66213267;  c[11][11]=-13.1930961; c[11][9]=-12.5573772;
    c[11][7]=-11.9330458;  c[11][5]=-11.3210061;  c[11][3]=-10.7222412;
    c[11][1]=-10.1378082;  c[12][12]=-14.7926394; c[12][10]=-14.1420915;
    c[12][8]=-13.5016616;  c[12][6]=-12.8721114;  c[12][4]=-12.2542699;
    c[12][2]=-11.6490374;  c[12][0]=-11.0573775;  c[13][13]=-16.4112395;
    c[13][11]=-15.7475710; c[13][9]=-15.0929680;  c[13][7]=-14.4480777;
    c[13][5]=-13.8136054;  c[13][3]=-13.1903162;  c[13][1]=-12.5790381;
    c[14][14]=-18.0466672; c[14][12]=-17.3712806; c[14][10]=-16.7040780;
    c[14][8]=-16.0456127;  c[14][6]=-15.3964878;  c[14][4]=-14.7573587;
    c[14][2]=-14.1289364;  c[14][0]=-13.5119848;  c[15][15]=-19.6970961;
    c[15][13]=-19.0111606; c[15][11]=-18.3326615; c[15][9]=-17.6620757;
    c[15][7]=-16.9999233;  c[15][5]=-16.3467686;  c[15][3]=-15.7032228;
    c[15][1]=-15.0699480;  c[16][16]=-21.3610081; c[16][14]=-20.6655103;
    c[16][12]=-19.9768082; c[16][10]=-19.2953176; c[16][8]=-18.6214885;
    c[16][6]=-17.9558093;  c[16][4]=-17.2988108;  c[16][2]=-16.6510652;
    c[16][0]=-16.0131906;  c[17][17]=-23.0371259; c[17][15]=-22.3329066;
    c[17][13]=-21.6349299; c[17][11]=-20.9435607; c[17][9]=-20.2591899;
    c[17][7]=-19.5822454;  c[17][5]=-18.9131878;  c[17][3]=-18.2525157;
    c[17][1]=-17.6007672;  c[18][18]=-24.7243611; c[18][16]=-24.0121449;
    c[18][14]=-23.3056902; c[18][12]=-22.6053167; c[18][10]=-21.9113705;
    c[18][8]=-21.2242247;  c[18][6]=-20.5442836;  c[18][4]=-19.8719830;
    c[18][2]=-19.2077941;  c[18][0]=-18.5522234;  c[19][19]=-26.4217792;
    c[19][17]=-25.7021950; c[19][15]=-24.9879497; c[19][13]=-24.2793271;
    c[19][11]=-23.5766321; c[19][9]=-22.8801952;  c[19][7]=-22.1903709;
    c[19][5]=-21.5075437;  c[19][3]=-20.8321263;  c[19][1]=-20.1645647;
    c[20][20]=-28.1285704; c[20][18]=-27.4021674; c[20][16]=-26.6807314;
    c[20][14]=-25.9645140; c[20][12]=-25.2537867; c[20][10]=-24.5488420;
    c[20][8]=-23.8499943;  c[20][6]=-23.1575823;  c[20][4]=-22.4719720;
    c[20][2]=-21.7935548;  c[20][0]=-21.1227537;

    w=gexp(dbltor(c[N][R1]),6);
    for (i=1; i<=20; i++) free(c[i]); free(c);
    p1=gmul(gsqrt(DK,6),w);
    tetpil=avma; return gerepile(av,tetpil,ground(p1));
  }

  av=avma; R2=(N-R1)>>1;
  p1=gdiv(mpfact(N),gpuigs(stoi(N),N));
  minkowskibound=ground(gmul(gmul(p1,gpuigs(gdivsg(4,mppi(6)),R2)),gsqrt(DK,6)));
  if (cmpis(minkowskibound,500000)>0)
    err(talker,"The field has degree more than 20 and the Minkowski bound is larger than 500 000: it is unrealistic to certify it");

  tetpil=avma; return gerepile(av,tetpil,gcopy(minkowskibound));
}

/* l'ideal est premier (5 composantes) et la factor base est ordonnee */
static long
isinfactorbase(GEN factorbase,GEN ideal) 
{
  long i,j,lgfb;
  GEN p,alpha;

  lgfb=lg(factorbase)-1;
  p=(GEN)ideal[1]; alpha=(GEN)ideal[2];
  i=1;
  while (i<=lgfb && gcmp(p,gmael(factorbase,i,1)) > 0) i++;

  if (i>lgfb) return 0;
  if (!gegal(p,gmael(factorbase,i,1))) return 0;
  if (gegal(alpha,gmael(factorbase,i,2))) return 1;

  j=i+1;
  while (j<=lgfb && gegal(p,gmael(factorbase,j,1)))
  {
    if (gegal(alpha,gmael(factorbase,j,2))) return 1;
    j++;
  }
  return 0;
}

static void
testprimeuptominkowskibound(GEN bnf,GEN minkowskibound)
{
  byteptr delta;
  long av,pp,i,nbideal,N,lgfb,fl;
  GEN nf,f,p1,vectpp,different,factorbase,pmax,dK;

  if (DEBUGLEVEL)
  {
    fprintferr("\nPHASE 1 : prime up to Zimmert bound are in computed class group ?\n\n");
    flusherr();
  }
  av=avma;
  nf=(GEN)bnf[7]; N=lgef(nf[1])-3; f=(GEN)nf[4]; dK=(GEN)nf[3];
  if (!gcmp1(f))
  {
    different=gmael(nf,5,5);
    if (DEBUGLEVEL)
    {
      fprintferr("***** Testing the Different = ");
      outerr(different); flusherr();
    }
    p1=isprincipalall(bnf,different,0);
    if (DEBUGLEVEL>1)
    {
      fprintferr("      The answer is "); outerr(p1); flusherr();
    }
  }
  avma=av;
  factorbase=(GEN)bnf[5]; lgfb=lg(factorbase)-1;
  pmax=gmael(factorbase,lgfb,1);
  delta=diffptr; pp=*delta++;
  while (cmpsi(pp,minkowskibound)<1)
  {
    if (DEBUGLEVEL)
    {
      fprintferr("*** Testing prime p = %ld\n",pp); flusherr();
    }
    vectpp=primedec(bnf,stoi(pp)); nbideal=lg(vectpp)-1;
    if (gdivise(dK,stoi(pp))) fl=1; else fl=0;
    for (i=1; i<(nbideal+fl); i++)
    {
      if (DEBUGLEVEL)
      {
	fprintferr("..... Testing ideal P = ");
	outerr((GEN)vectpp[i]); flusherr();
      }
      if (cmpis(gmael(vectpp,i,4),N) && 
          cmpii(idealnorm(bnf,(GEN)vectpp[i]),minkowskibound) < 1)
      {
	if (cmpsi(pp,pmax)<=0 && isinfactorbase(factorbase,(GEN)vectpp[i]))
	{
	  if (DEBUGLEVEL>1)
	  {
	    fprintferr("      The prime ideal is in the factor base\n");
	    flusherr();
	  }
	}
	else
	{
	  p1=isprincipalall(bnf,(GEN)vectpp[i],0);
	  if (DEBUGLEVEL>1)
	  {
	    fprintferr("      The answer is ");
	    outerr(p1); flusherr();
	  }
	}
/* Il vaudrait mieux attraper le message d'erreur en cas d'echec !! */
      }
      else
      {
	if (DEBUGLEVEL>1)
	{
	  fprintferr("      Norm ideal > Zimmert bound\n"); flusherr();
	}
      }
    }
    pp+=*delta++;
  }
  avma=av;
  if (DEBUGLEVEL)
  {
    fprintferr("\nEnd of PHASE 1.\n\n\n");
    flusherr();
  }
}

#if 0
static GEN
mynfshanks(GEN nf,GEN x,GEN g0,GEN pr,GEN prhall)
/* rend le plus petit entier positif n tel que g0^n=x=1 modulo pr */
{
  long av,tetpil,i,N,lbaby,fl;
  GEN pf1,pfqr,p1,smalltable,p2,giant,smalltable2,permtable,pp,unmodp,p3,kgen;

  av=avma; pp=(GEN)pr[1];
  pf1=addsi(-1,gpui((GEN)pr[1],(GEN)pr[4],0)); pfqr=racine(pf1);
  unmodp=gmodulcp(gun,pp);
  if (cmpis(pfqr,65535)>=0) err(talker,"module is too large in mynfshanks");
  lbaby=itos(pfqr); N=lgef(nf[1])-3;
  p1=g0; p2=cgetg(N+1,t_COL); p2[1]=un; for (i=2; i<=N; i++) p2[i]=zero;
  smalltable=cgetg(lbaby+1,t_VEC); fl=0;
  for (i=1; (i<=lbaby)&&(!fl); i++)
  {
    smalltable[i]=(long)lift(element_mulmodpr(nf,p1,p2,prhall));
    p2=(GEN)smalltable[i];
    p3=lift(gmul(unmodp,gsub(p2,x))); fl=gcmp0(p3);
  }
  if (fl){ avma=av; return stoi(i-1); }
  permtable=indexlexsort(smalltable); smalltable2=cgetg(lbaby+1,t_VEC);
  for (i=1; i<=lbaby; i++)
    smalltable2[i]=smalltable[itos((GEN)permtable[i])];
  giant=(GEN)smalltable[lbaby];
  smalltable=smalltable2;
  kgen=stoi(lbaby); p2=giant;
  for(;;)
  {
    kgen=addis(kgen,lbaby);
    p2=lift(element_mulmodpr(nf,giant,p2,prhall));
    i=nfsearch(smalltable,p2);
    if (i)
    { 
      tetpil=avma;
      return gerepile(av,tetpil,subii(kgen,(GEN)permtable[i]));
    }
  }
}
#endif

/* rend constante d'Hermite^n si connue, sinon une borne sup */
static GEN
hermiteconstant(long n)
{
  long av=avma,tetpil;
  GEN h;

  switch(n)
  {
    case 1: h=gun; break;
    case 2: h=gdivgs(stoi(4),3); break;
    case 3: h=gdeux; break;
    case 4: h=stoi(4); break;
    case 5: h=stoi(8); break;
    case 6: h=gdivgs(stoi(64),3); break;
    case 7: h=stoi(64); break;
    case 8: h=stoi(256); break;
    default: h=gmul(gpuigs(gdiv(gdeux,mppi(5)),n),gsqr(ggamma(gdivgs(stoi(n+4),2),5)));
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(h));
}

/* 1 primitif, 0 s'il est peut etre imprimitif... */
static long
isprimitive(GEN nf)
{
  long N,firstfactor,i,av,lfdK,maxexpo;
  GEN dK,fN,fN1,fdK,fdK2;

  av=avma; N=lgef(nf[1])-3;
  dK=(GEN)nf[3];
  fN=factor(stoi(N)); fN1=(GEN)fN[1];
  firstfactor=itos((GEN)fN1[1]);
  if (firstfactor==N){ avma=av; return 1; }
  fdK=factor(absi(dK)); fdK2=(GEN)fdK[2]; lfdK=lg(fdK2)-1;
  if (mpodd(dK)) { maxexpo=1; i=1; }
  else { maxexpo=itos((GEN)fdK2[1])>>1; i=2; }
  for (; i<=lfdK; i++) maxexpo=max(maxexpo,itos((GEN)fdK2[i]));
  avma=av; return (long)(maxexpo<firstfactor);
}

static GEN
badboundforregulator(GEN bnf)
{
  long av,tetpil,N,R1,R2,R;
  GEN nf,dKa,defaultbound,p1,signature,c1;

  av=avma;
  nf=(GEN)bnf[7];
  N=lgef(nf[1])-3;
  defaultbound=dbltor(0.2);
  if (!isprimitive(nf))
  {
    if (DEBUGLEVEL)
    { 
      fprintferr("Default bound for regulator: 0.2\n");
      flusherr();
    }
    av=avma; return defaultbound;
  }

  dKa=absi((GEN)nf[3]); signature=(GEN)nf[2];
  R1=itos((GEN)signature[1]); R2=itos((GEN)signature[2]);
  R=R1+R2-1;
  if (!R2 && N<12) c1=gpuigs(stoi(4),N>>1); else c1=gpuigs(stoi(N),N);
  if (cmpii(dKa,c1)<=0)
  {
    if (DEBUGLEVEL)
    { 
      fprintferr("Default bound for regulator: 0.2\n");
      flusherr();
    }
    av=avma; return defaultbound;
  }
  p1=gmax(defaultbound,gsqrt(gdiv(gdivgs(gmul2n(gpuigs(gdivgs(gmulgs(gsqr(glog(gdiv(dKa,c1),DEFAULTPREC)),3),N*(N*N-1)-6*R2),R),R2),N),hermiteconstant(R)),DEFAULTPREC));
  if (DEBUGLEVEL)
  { 
    fprintferr("Mahler bound for regulator: ");
    outerr(p1); flusherr();
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(p1));
}

#define NBMAX 5000

static GEN
minimforunits(GEN nf, long borne, long stockmax)
{
  GEN u,r,unr,S,S1,a,base,p1;
  long n1,n,av,av1,i,j,k,s,norme,normax,flg,*x,fl1,cmpt;
  double p,b,c;
  double **q,*v,*y,*z;
  double eps=0.000001;

  av=avma;
  if (DEBUGLEVEL)
  { 
    fprintferr("Searching minimum of T2-form on units: ");
    if (DEBUGLEVEL>2) fprintferr("\n   borne = %ld\n",borne);
    flusherr();
  }
  nf=checknf(nf);
  a=gmael(nf,5,3); n1=lg(a);
  n=n1-1;
  x=(long*)xmalloc(n1*sizeof(long));
  y=(double*)xmalloc(n1*sizeof(double));
  z=(double*)xmalloc(n1*sizeof(double));
  v=(double*)xmalloc(n1*sizeof(double));
  q=(double**)xmalloc(n1*sizeof(double*));
  for (j=1; j<=n; j++) q[j]=(double*)xmalloc(n1*sizeof(double));
  affsr(1,unr=cgetr(10));
  u=lllgram(a,BIGDEFAULTPREC); base=gmul((GEN)nf[7],u);
  a=gmul(gtrans(u),gmul(a,u)); a=gmul(a,unr);
  r=sqred1(a);
  for (j=1; j<=n; j++)
  {
    v[j]=rtodbl(gcoeff(r,j,j));
    for (i=1; i<j; i++)
      q[i][j]=rtodbl(gcoeff(r,i,j));
  }
  flg=borne; /* flg=0 <==> chercher les vec min */
  if (!flg)   
  {
    b=rtodbl(gcoeff(a,1,1));
    for (i=2; i<=n; i++)
      if ((c=rtodbl(gcoeff(a,i,i)))<b) b=c;
    borne=(long)(b+eps);
  }
  normax=0;
  if (stockmax) S=cgetg(stockmax+1,t_MAT);
  s=0; k=n; cmpt=0;
  y[n]=z[n]=0;
  x[n]=(long)(sqrt(borne/v[n]+eps));

  for(;;)
  {
    do
    {
      if (k>1)
      {
	k--;
	z[k]=0;
	for (j=k+1; j<=n; j++) z[k]=z[k]+q[k][j]*x[j];
	p=x[k+1]+z[k+1];
	y[k]=y[k+1]+p*p*v[k+1];
	x[k]=(long)floor(sqrt((borne-y[k]+eps)/v[k])-z[k]);
      }
      while (v[k]*(x[k]+z[k])*(x[k]+z[k]) > borne-y[k]+eps)
      { 
	k++; x[k]--;
      }
    }
    while (k>1);
    if (!x[1] && y[1]<=eps) break;

    cmpt++;
    if (cmpt>NBMAX)
    {
      free(x); free(y); free(z); free(v);
      for (j=1; j<=n; j++) free(q[j]); free(q);
      av=avma; return gzero;
    }
    if (DEBUGLEVEL>8){ fprintferr("."); flusherr(); }
    norme=(long)(y[1]+v[1]*(x[1]+z[1])*(x[1]+z[1])+eps);
    if (!flg && norme<borne) { s=0; borne=norme; }
    if (norme>normax) normax=norme;
    av1=avma; p1=gzero;
    for (i=1; i<=n; i++) p1=gadd(p1,gmulsg(x[i],(GEN)base[i]));
    fl1=gcmp1(gabs(subres(p1,(GEN)nf[1]),0)); avma=av1;
    if (fl1)
    {
      if (DEBUGLEVEL) { fprintferr("*"); flusherr(); }
      s++; cmpt=0;
      if (s<=stockmax)
      {
	p1=cgetg(n+1,t_COL);
	for (i=1; i<=n; i++) p1[i]=lstoi(x[i]);
	S[s]=lmul(u,p1);
      }
    }
    x[k]--;
  }
  free(x); free(y); free(z); free(v);
  for (j=1; j<=n; j++) free(q[j]); free(q);
  if (DEBUGLEVEL){ fprintferr("\n"); flusherr(); }
  if (stockmax)
  {
    av1=avma;
    k=(s<stockmax)? s:stockmax;
    S1=cgetg(k+1,t_MAT);
    for (j=1; j<=k; j++) S1[j]=lcopy((GEN)S[j]);
    S=gerepile(av,av1,S1);
  }
  else { avma=av; S=cgetg(1,t_MAT); }
  u=cgetg(4,t_VEC);
  u[1]=lstoi(s<<1);
  u[2]=(flg)?lstoi(normax):lstoi(borne);
  u[3]=(long)S;
  return u;
}

#undef NBMAX

static GEN
compute_M0(GEN M_star,long N) /* On connait M_star; on calcule M0 */
{
  long av,av1,tetpil,m1,m2,n1,n2,n3,k,kk,lr,lr1,lr2,i,j,l,vx,vy,vz,vM,PREC,prec;
  GEN eps,pol,p1,p2,p3,p4,p5,p6,u,v,w,r,r1,r2,M0,M0_pro,S,P,M_formel;
  GEN f1,f2,f3,g1,g2,g3,pg1,pg2,pg3,pf1,pf2,pf3,p7,p8,p9,p10,p11;
  GEN x,y,z;

  av=avma; PREC=gprecision(M_star);
  x=lisexpr("x"); y=lisexpr("y");
  z=lisexpr("z"); M_formel=lisexpr("M_formel");
  vx=varn(x); vy=varn(y); vz=varn(z); vM=varn(M_formel);
  if (N==2)
  {
    M0=gmul2n(gsqr(gach(gmul2n(M_star,-1),PREC)),-1); tetpil=avma;
    return gerepile(av,tetpil,gcopy(M0));
  }

  eps=dbltor(0.0000001); M0=gzero; m1=(N-(N%3))/3;
  for (n1=1; n1<=m1; n1++)
  {
    m2=((N-n1)-((N-n1)%2))/2;
    for (n2=n1; n2<=m2; n2++)
    {
      n3=N-n1-n2; prec=(PREC>>1); if (!prec) prec=5;
      if ((!(N%3))&&(n1==n2)&&(n1==n3))
      {
	av1=avma;
	p1=gdivgs(M_star,m1); p2=gaddsg(1,p1); p3=gsubgs(p1,3);
	p4=gsqrt(gmul(p2,p3),prec); p5=gsubgs(p1,1);
	u=gun; v=gmul2n(gadd(p5,p4),-1); w=gmul2n(gsub(p5,p4),-1);
	M0_pro=gmul2n(gmulsg(m1,gadd(gsqr(glog(v,prec)),gsqr(glog(w,prec)))),-2);
	if (DEBUGLEVEL>2)
	{ 
	  fprintferr("[ %ld,%ld,%ld ] : ",n1,n2,n3);
	  outerr(M0_pro); flusherr();
	}
	if (gcmp0(M0) || gcmp(M0_pro,M0)<0)
	{ 
	  M0=M0_pro; tetpil=avma; M0=gerepile(av1,tetpil,gcopy(M0));
	}
	else avma=av1;
      }
      else if (n1==n2 || n1==n3 || n2==n3)
      {
	av1=avma;
	if (n1==n2) k=n1; else if (n2==n3) k=n3; kk=N-2*k;
	p2=gsub(M_star,gmulgs(x,k));
	p3=gmul(gpuigs(stoi(kk),kk),gpuigs(gsubgs(gmul(M_star,p2),kk*kk),k));
	pol=gsub(p3,gmul(gmul(gpuigs(stoi(k),k),gpuigs(x,k)),gpuigs(p2,N-k)));
	prec=gprecision(pol); if (!prec) prec=5;
	r=roots(pol,prec); lr=lg(r)-1;
	for (i=1; i<=lr; i++)
	{
	  if (gcmp(gabs(gimag((GEN)r[i]),prec),eps) < 0 &&
	      gsigne(S=greal((GEN)r[i])) > 0)
	  {
	    p4=gsub(M_star,gmulsg(k,S));
	    P=gdiv(gmul(gmulsg(k,S),p4),gsubgs(gmul(M_star,p4),kk*kk));
	    p5=gsub(gsqr(S),gmul2n(P,2));
	    if (gsigne(p5)>=0)
	    {
	      p6=gsqrt(p5,prec);
	      u=gmul2n(gadd(S,p6),-1); v=gmul2n(gsub(S,p6),-1);
	      if ((gsigne(u)>0)&&(gsigne(v)>0))
	      {
		w=gpui(P,gneg(gdivgs(stoi(k),kk)),prec);
		p6=gmulsg(k,gadd(gsqr(glog(u,prec)),gsqr(glog(v,prec))));
		M0_pro=gmul2n(gadd(p6,gmulsg(kk,gsqr(glog(w,prec)))),-2);
		if (DEBUGLEVEL>2)
		{ 
		  fprintferr("[ %ld,%ld,%ld ] : ",n1,n2,n3); 
		  outerr(M0_pro); flusherr();
		}
		if (gcmp0(M0) || gcmp(M0_pro,M0)<0) M0=M0_pro;
	      }
	    }
	  }
	}
	tetpil=avma; M0=gerepile(av1,tetpil,gcopy(M0));
      }
      else
      {
	av1=avma;
	f1=gadd(gmulsg(n1,x),gadd(gmulsg(n2,y),gmulsg(n3,z)));
	f1=gsub(f1,M_formel);
	f2=gmulsg(n1,gmul(y,z));
	f2=gadd(f2,gmulsg(n2,gmul(x,z)));
	f2=gadd(f2,gmulsg(n3,gmul(x,y)));
	f2=gsub(f2,gmul(M_formel,gmul(x,gmul(y,z))));
	f3=gsub(gmul(gpuigs(x,n1),gmul(gpuigs(y,n2),gpuigs(z,n3))),gun);
	g1=subres(f1,f2); g1=gdiv(g1,content(g1));
	g2=subres(f1,f3); g2=gdiv(g2,content(g2));
	g3=subres(g1,g2); g3=gdiv(g3,content(g3));
	pf1=gsubst(f1,vM,M_star); pg1=gsubst(g1,vM,M_star);
	pf2=gsubst(f2,vM,M_star); pg2=gsubst(g2,vM,M_star);
	pf3=gsubst(f3,vM,M_star); pg3=gsubst(g3,vM,M_star);
	prec=gprecision(pg3); if (!prec) prec=5;
	r=roots(pg3,prec); lr=lg(r)-1;
	for (i=1; i<=lr; i++)
	{
	  if (gcmp(gabs(gimag((GEN)r[i]),prec),eps) < 0 &&
	      gsigne(w=greal((GEN)r[i])) > 0)
	  {
	    p1=gsubst(pg1,vz,w); p2=gsubst(pg2,vz,w);
	    p3=gsubst(pf1,vz,w); p4=gsubst(pf2,vz,w); p5=gsubst(pf3,vz,w);
	    prec=gprecision(p1); if (!prec) prec=5;
	    r1=roots(p1,prec); lr1=lg(r1)-1;
	    for (j=1; j<=lr1; j++)
	    {
	      if (gcmp(gabs(gimag((GEN)r1[j]),prec),eps) < 0 &&
	         gsigne(v=greal((GEN)r1[j])) > 0)
	      {
		p6=gsubst(p2,vy,v);
		if (gcmp(gabs(p6,prec),eps)<0)
		{
		  p7=gsubst(p3,vy,v); p8=gsubst(p4,vy,v); p9=gsubst(p5,vy,v);
		  prec=gprecision(p7); if (!prec) prec=5;
		  r2=roots(p7,prec); lr2=lg(r2)-1;
		  for (l=1; l<=lr2; l++)
		  {
		   if (gcmp(gabs(gimag((GEN)r2[l]),prec),eps) < 0 &&
		       gsigne(u=greal((GEN)r2[l])) > 0)
		   {
		     p10=gsubst(p8,vx,u);
		     if (gcmp(gabs(p10,prec),eps)<0)
		     {
		       p11=gsubst(p9,vx,u);
		       if (gcmp(gabs(p11,prec),eps)<0)
		       {
			 M0_pro=gmulsg(n1,gsqr(glog(u,prec)));
			 M0_pro=gadd(M0_pro,gmulsg(n2,gsqr(glog(v,prec))));
			 M0_pro=gadd(M0_pro,gmulsg(n3,gsqr(glog(w,prec))));
			 M0_pro=gmul2n(M0_pro,-2);
			 if (DEBUGLEVEL>2)
			 { 
			   fprintferr("[ %ld,%ld,%ld ] : ",n1,n2,n3);
			   outerr(M0_pro); flusherr();
			 }
			 if (gcmp0(M0) || gcmp(M0_pro,M0) < 0) M0=M0_pro;
		       }
		     }
		   }
		 }
		}
	      }
	    }
	  }
	}
	tetpil=av1; M0_pro=gerepile(av1,tetpil,gcopy(M0));
      }
    }
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(M0));
}

static GEN
lowerboundforregulator(GEN bnf,GEN units)
{
  long av,N,R1,R2,R,tetpil,i,nbrootsofone,nbmin;
  GEN rootsofone,nf,signature,M0,M,m,col,T2,bound,minunit,newminunit;
  GEN unitsonbasis,vecminim,colalg,p1,pol,y;

  av=avma;
  rootsofone=gmael(bnf,8,4); nbrootsofone=itos((GEN)rootsofone[1]);
  nf=(GEN)bnf[7]; T2=gmael(nf,5,3); N=lgef(nf[1])-3;
  signature=(GEN)nf[2];
  R1=itos((GEN)signature[1]); R2=itos((GEN)signature[2]); R=R1+R2-1;
  if (N==1 || (N==2 && !R1)) return gun;

  unitsonbasis=algtobasis(bnf,units);
  minunit=gmul(gmul(gtrans((GEN)unitsonbasis[1]),T2),(GEN)unitsonbasis[1]);
  for (i=2; i<=R; i++)
  {
    newminunit=gmul(gmul(gtrans((GEN)unitsonbasis[i]),T2),(GEN)unitsonbasis[i]);
    if (gcmp(newminunit,minunit)<0) minunit=newminunit;
  }
  if (gcmpgs(minunit,1000000000)>0)
  { 
    avma=av;
    return badboundforregulator(bnf);
  }

  vecminim=minimforunits(nf,itos(gceil(minunit)),10000);
  if (gcmp0(vecminim)){ av=avma; return badboundforregulator(bnf); }
  m=(GEN)vecminim[3]; nbmin=lg(m)-1;
  if (nbmin==10000){ avma=av; return badboundforregulator(bnf); }
  bound=gaddgs(minunit,1);
  for (i=1; i<=nbmin; i++)
  {
    col=(GEN)m[i]; colalg=basistoalg(nf,col);
    if (!gcmp1(lift(gpuigs(colalg,nbrootsofone))))
    {
      newminunit=gmul(gmul(gtrans(col),T2),col);
      if (gcmp(newminunit,bound)<0) bound=newminunit;
    }
  }
  if (gcmp(bound,minunit)>0) err(talker,"bug in lowerboundforregulator");
  if (DEBUGLEVEL)
  {
    fprintferr("M* = "); outerr(bound); flusherr();
    if (DEBUGLEVEL>2)
    {
      p1=polx[0]; pol=gaddgs(gsub(gpuigs(p1,N),gmul(bound,p1)),N-1);
      fprintferr("pol = "); outerr(pol); flusherr();
      p1=roots(pol,6);
      if (N&1) y=greal((GEN)p1[3]); else y=greal((GEN)p1[2]);
      fprintferr("y = "); outerr(y); flusherr();
      M0=gmul2n(gmulsg(N*(N-1),gsqr(glog(y,6))),-2);
      fprintferr("old fashion M0 = "); outerr(M0); flusherr();
    }
  }
  M0=compute_M0(bound,N);
  if (DEBUGLEVEL)
  {
    fprintferr("M0 = "); outerr(M0); flusherr();
  }
  M=gmul2n(gdivgs(gdiv(gpuigs(M0,R),hermiteconstant(R)),N),R2);
  if (gcmp(M,dbltor(0.04))<0)
  { 
    avma=av;
    return badboundforregulator(bnf);
  }
  if (DEBUGLEVEL)
  {
    fprintferr("(lower bound for regulator) M = ");
    outerr(gsqrt(M,6)); flusherr();
  }
  tetpil=avma; return gerepile(av,tetpil,gsqrt(M,6));
}

#if 0
/* calcule un generateur du groupe cyclique (Zk/pr)* */
static GEN
computeprimelement(GEN bnf,GEN pr,GEN prhall)
{
  long N,f,i,j,*vec,*vecindex,av,av1,tetpil,r;
  GEN nf,pp,pfm1,ideal,bun,lambda,blambda,order;

  av=avma;
  nf=(GEN)bnf[7]; N=lgef(nf[1])-3; pp=(GEN)pr[1]; f=itos((GEN)pr[4]);
  pfm1=addis(gpuigs(pp,f),-1);
  ideal=idealmul(nf,pr,idmat(N));
  vec=(long*)xmalloc(sizeof(long)*(N+1)); for (i=1; i<=N; i++) vec[i]=0;
  vecindex=(long*)xmalloc(sizeof(long)*(f+1));
  j=0;
  for (i=1; i<=N; i++)
    if (gegal(gcoeff(ideal,i,i),pp)) vecindex[++j]=i;
  bun=cgetg(N+1,t_COL); bun[1]=un;
  for (i=2; i<=N; i++) bun[i]=zero;
  r=1; for (i=1; i<=f; i++) vec[vecindex[i]]=r;
  av1=avma;
  for(;;)
  {
    avma=av1;
    lambda=cgetg(N+1,t_VEC); for (i=1; i<=N; i++) lambda[i]=(long)stoi(vec[i]);
    blambda=gtrans(lambda);
    order=mynfshanks(nf,bun,blambda,pr,prhall);
    if (DEBUGLEVEL>1)
    {
      fprintferr("               The element "); outerr(blambda);
      fprintferr("               has order "); outerr(order);
      flusherr();
    }

    if (gegal(order,pfm1)) break;

    for (j=f; (vec[vecindex[j]]+r)==0; j--);
    vec[vecindex[j]]--;
    for (i=j+1; i<=f; i++) vec[vecindex[i]]=r;
    for (j=1; (j<f)&&(!vec[vecindex[j]]); j++);
    if (!vec[vecindex[j]])
    {
      r++; for (i=1; i<=f; i++) vec[vecindex[i]]=r;
      if (cmpis(pp,(r<<1))<0) err(talker,"bug in computeprimelement");
    }
  }
  free(vec); free(vecindex); tetpil=avma;
  return gerepile(av,tetpil,gcopy(blambda));
}
#endif

/* Calcule une matrice carree de rang lg(beta) associee a une famille
 * d'ideaux premiers P_i tels que : 1<=i<=nombre de beta; N(P_i) congru a 1
 * mod pp v_(P_i)(beta[j])=0 pour tout 1<=j<=nbalphapro et 1<=i<=lg(beta)
 */
static void
primecertify(GEN bnf,GEN beta,long pp,GEN big)
{
  long av=avma,i,j,qq,nbcol,sizeofmat,nbqq,ra,N;
  GEN nf,mat,mat1,qgen,decqq,newcol,eltgen,qrhall,ideal;

  nbcol=0; nf=(GEN)bnf[7]; N=lgef(nf[1])-3;
  sizeofmat=lg(beta)-1; mat=cgetg(1,t_MAT);
  qq=2*pp+1; qgen=stoi(qq);
  for(;;)
  {
    if (isprime(qgen) && !gdivise(big,qgen))
    {
      decqq=primedec(bnf,qgen); nbqq=lg(decqq)-1;
      for (i=1; i<=nbqq; i++)
      {
	ideal=(GEN)decqq[i];
	if (itos((GEN)ideal[4])==1)
	{
	  qrhall=compute_prhall(nf,ideal);
	  nbcol++;
	  newcol=cgetg(sizeofmat+1,t_COL);
	  if (DEBUGLEVEL>1)
	  {
	    fprintferr("          The prime number q : %ld\n",qq);
	    fprintferr("          The prime ideal Q : "); outerr(ideal);
	    flusherr();
	  }
	  
	  eltgen=cgetg(N+1,t_COL); eltgen[1]=llift(gener(qgen));
	  for (j=2; j<=N; j++) eltgen[j]=zero;
	  for (j=1; j<=sizeofmat; j++)
	    newcol[j]=(long)nfshanks(nf,(GEN)beta[j],eltgen,ideal,qrhall);
	  if (DEBUGLEVEL>1)
	  {
	    fprintferr("          The generator of (Zk/Q)^* : ");
	    outerr(eltgen);
	    fprintferr("          The column #%ld of the matrix log(b_j/Q) : ",nbcol);
	    outerr(newcol); flusherr();
	  }
	  mat1=concat(mat,newcol); ra=rank(mat1);
	  if (DEBUGLEVEL>1)
	  {
	    fprintferr("          The new rank of the matrix : %ld\n\n",ra);
	    flusherr();
	  }
	  if (ra!=nbcol) nbcol--;
	  else
	  {
	    mat=mat1;
	    if (nbcol==sizeofmat) { avma=av; return; }
	  }
	}
      }
    }
    qq+=2*pp; qgen=stoi(qq);
  }
}

long
certifybuchall(GEN bnf)
{
  byteptr delta;
  long nbgenerator,i,j,pp,N,R1,R2,R,av,av1,nfa,nbf1,nbalpha,nbalphapro,fl;
  GEN nf,cl,reg,rootsofone,fundunits,generator,p1,boundforprime;
  GEN zimmertbound,DK,alpha,factfd1,f1,classnumber;
  GEN cycliccomponent,nbrootsofone,pgen,beta,big;

  av=avma;
  nf=(GEN)bnf[7]; N=lgef(nf[1])-3; if (N==1) return 1;
  R1=itos(gmael(nf,2,1)); R2=itos(gmael(nf,2,2)); R=R1+R2-1;
  DK=absi((GEN)nf[3]);
  zimmertbound=computezimmertbound(N,R1,DK);
  if (DEBUGLEVEL)
  { 
    fprintferr("Zimmert's bound = ");
    outerr(zimmertbound); flusherr();
  }
  testprimeuptominkowskibound(bnf,zimmertbound);
  cl=gmael(bnf,8,1); classnumber=(GEN)cl[1];
  cycliccomponent=(GEN)cl[2]; nbgenerator=lg(cycliccomponent)-1;
  generator=(GEN)cl[3]; reg=gmael(bnf,8,2);
  rootsofone=gmael(bnf,8,4); nbrootsofone=(GEN)rootsofone[1];
  fundunits=(GEN)buchfu(bnf)[1];
  if (DEBUGLEVEL)
  {
    fprintferr("Class number = "); outerr(classnumber);
    fprintferr("Cyclic components = "); outerr(cycliccomponent);
    fprintferr("Generators = "); outerr(generator);
    fprintferr("Regulator = "); outerr(reg);
    fprintferr("Roots of one = "); outerr(rootsofone);
    fprintferr("Fundamental units = "); outerr(fundunits);
    flusherr();
  }
  alpha=cgetg(nbgenerator+1,t_VEC);
  for (i=1; i<=nbgenerator; i++)
  {
    p1=idealpow(nf,(GEN)generator[i],(GEN)cycliccomponent[i]);
    alpha[i]=isprincipalall(bnf,p1,3)[2];
  }
  boundforprime=ground(gdiv(reg,lowerboundforregulator(bnf,fundunits)));

  if (DEBUGLEVEL)
  {
    fprintferr("\nPHASE 2 : are all primes good ?\n\n");
    fprintferr("  Bound for testing primes : B = ");
    outerr(boundforprime); flusherr();
  }
  nfa=0;
  if (nbgenerator)
  {
    factfd1=factor((GEN)cycliccomponent[1]);
    nbf1=lg(factfd1[1])-1; f1=(GEN)factfd1[1]; nfa=0;
    for (i=1; i<=nbf1; i++)
      if (cmpii((GEN)f1[i],boundforprime) > 0) nfa++;
  }
  if (DEBUGLEVEL)
  {
    fprintferr("  Number of primes > boundforprime = %ld\n",nfa);
    flusherr();
  }
  delta=diffptr; pp=*delta++; pgen=stoi(pp);
  if (DEBUGLEVEL)
  {
    fprintferr("\n  Testing primes <= B\n\n"); flusherr();
  }

  while (cmpsi(pp,boundforprime)<1)
  {
    if (DEBUGLEVEL)
    {
      fprintferr("\n***** Testing prime p = %ld\n",pp); flusherr();
    }
    av1=avma; nbalphapro=0;
    if (gdivise(classnumber,pgen))
    {
      if (DEBUGLEVEL>1)
      {
	fprintferr("      p divides cl(k)\n"); flusherr();
      }
      nbalphapro=nbgenerator;
      while (nbalphapro>0)
      { 
	if (gdivise((GEN)cycliccomponent[nbalphapro],pgen)) break;
        nbalphapro--;
      }
    }
    if (gdivise(nbrootsofone,pgen))
    {
      if (DEBUGLEVEL>1)
      {
	fprintferr("      p divides w(k)\n"); flusherr();
      }
      fl=1; nbalpha=nbalphapro+1+R;
    }
    else { fl=0; nbalpha=nbalphapro+R; }
    if (DEBUGLEVEL>1)
    {
      fprintferr("      t+r+e = %ld\n",nbalpha); flusherr();
    }
    beta=cgetg(nbalpha+1,t_VEC);
    for (i=1; i<=nbalphapro; i++) beta[i]=alpha[i];
    if (fl) beta[nbalphapro+1]=(long)algtobasis(nf,(GEN)rootsofone[2]);
    for (i=1; i<=R; i++)
      beta[i+nbalphapro+fl]=(long)algtobasis(nf,(GEN)fundunits[i]);
    if (DEBUGLEVEL>1)
    {
      fprintferr("      Beta list = ");
      outerr(beta); fprintferr("\n"); flusherr();
    }
    big=gun;
    for (i=1; i<=nbgenerator; i++)
      big=gmul(big,idealnorm(nf,(GEN)generator[i]));
    primecertify(bnf,beta,pp,big);
    avma=av1; pp+=*delta++; pgen=stoi(pp);
  }

  for (j=1; j<=nfa; j++)
  {
    if (DEBUGLEVEL)
    {
      fprintferr("  Testing primes > B\n\n"); flusherr();
    }
    av1=avma;
    pgen=(GEN)f1[nbf1-j+1]; pp=itos(pgen);
    if (DEBUGLEVEL)
    {
      fprintferr("***** Testing prime p = %ld\n",itos(pgen)); flusherr();
    }
    nbalphapro=nbgenerator;
    while (nbalphapro>0)
    { 
      if (gdivise((GEN)cycliccomponent[nbalphapro],pgen)) break;
      nbalphapro--;
    }
    if (gdivise(nbrootsofone,pgen)) { fl=1; nbalpha=nbalphapro+1+R; }
    else { fl=0; nbalpha=nbalphapro+R; }
    if (DEBUGLEVEL>1)
    {
      fprintferr("      t+r+e = %ld\n",nbalpha); flusherr();
    }
    beta=cgetg(nbalpha+1,t_VEC);
    for (i=1; i<=nbalphapro; i++) beta[i]=alpha[i];
    if (fl) beta[nbalphapro+1]=(long)algtobasis(nf,(GEN)rootsofone[2]);
    for (i=1; i<=R; i++)
      beta[i+nbalphapro+fl]=(long)algtobasis(nf,(GEN)fundunits[i]);
    if (DEBUGLEVEL>1)
    {
      fprintferr("      Liste des beta = "); outerr(beta); flusherr();
    }
    big=gun;
    for (i=1; i<=nbgenerator; i++)
      big=gmul(big,idealnorm(nf,(GEN)generator[i]));
    primecertify(bnf,beta,pp,big);
    avma=av1;
  }
  avma=av; return 1;
}

/*******************************************************************/
/*                                                                 */
/*     CORPS DE CLASSES DE RAYON : CONDUCTEURS ET DISCRIMINANTS    */
/*                                                                 */
/*******************************************************************/

/* Programme interne. Si s est la surjection de Cl_m sur Cl_n et H
 * ssgroupe de Cl_m, retourne le cardinal de Cl_n/s(H)
 */
static GEN
cardofimagofquotientgroup(GEN generator,GEN bnr2,GEN subgroup)
{
  long av=avma,tetpil,j,nbgen;
  GEN E,p1,mat,cyclic2,classgroup2,Delta;

  classgroup2=(GEN)bnr2[5];
  if (gcmp0(subgroup)) return gcopy((GEN)classgroup2[1]);

  cyclic2=(GEN)classgroup2[2];
  Delta=diagonal(cyclic2);
  nbgen=lg(generator)-1;
  E=cgetg(nbgen+1,t_MAT);
  for (j=1; j<=nbgen; j++)
    E[j]=(long)isprincipalray(bnr2,(GEN)generator[j]);
  mat=concat(gmul(E,subgroup),Delta);
  p1=hnf(mat); tetpil=avma;
  return gerepile(av,tetpil,dethnf(p1));
}

static GEN
args_to_bnr(GEN arg0, GEN arg1, GEN arg2, GEN *subgroup, long prec)
{
  GEN bnr,bnf;

  if (typ(arg0)!=t_VEC)
    err(talker,"neither bnf nor bnr in conductor or discray");

  switch(lg(arg0))
  {
    case 7:  /* bnr */
      bnr=arg0; bnf=(GEN) bnr[1]; checkbnf(bnf);
      *subgroup=arg1;
      break;

    case 11: /* bnf */
      bnf=arg0; checkbnf(bnf);
      bnr=buchrayall(bnf,arg1,-1,prec);
      *subgroup=arg2;
      break;

    default: err(talker,"neither bnf nor bnr in conductor or discray");
  }
  if (!gcmp0(*subgroup))
  {
    const long tx=typ(*subgroup);
    if (!is_matvec_t(tx))
      err(talker,"bad subgroup in conductor or discray");
  }
  return bnr;
}

GEN
bnfconductor(GEN arg0,GEN arg1, GEN arg2,long prec)
{
  GEN bnr, subgroup=arg1;

  bnr=args_to_bnr(arg0,arg1,arg2,&subgroup,prec);
  return conductor(bnr,subgroup,prec);
}

/*    Etant donnes un corps de nombres bnf=bnr[1], un groupe de classes de
 *  rayon bnr calcule par buchrayinit(), et une matrice HNF subgroup
 *  definissant un sous-groupe du groupe de classes de rayon, calcule le
 *  conducteur de ce sous groupe (cf. discrayall()).
 */
GEN
conductor(GEN bnr,GEN subgroup,long prec)
{
  long r1,j,av=avma,tetpil,k,clhray,clhss,ep,flfin,trivial=0;
  GEN bnf,nf,classgroup,cyclic,generator,bid,module,ideal,arch,D,p1,p2;
  GEN fa,pr,arch2,bnr2,fa2,ex;

  checkbnrgen(bnr); bnf=(GEN)bnr[1];
  classgroup=(GEN)bnr[5]; cyclic=(GEN)classgroup[2];
  generator=(GEN)classgroup[3];
  nf=(GEN)bnf[7]; r1=itos((GEN)((GEN)nf[2])[1]);
  bid=(GEN)bnr[2]; module=(GEN)bid[1];
  ideal=(GEN)module[1]; arch=(GEN)module[2];
  D=diagonal(cyclic);
  if (gcmp0(subgroup)) { trivial=1; clhray=itos((GEN)classgroup[1]); }
  else
  {
    if (!gcmp1(denom(p1=invmulmat(subgroup,D))))
      err(talker,"incorrect subgroup in conductor");
    if (gcmp1(det(p1))) trivial=1;
    clhray=itos(gabs(det(subgroup),0));
  }
  fa=(GEN)bid[3]; fa2=(GEN)fa[1]; ex=(GEN)fa[2];
  p2=cgetg(3,t_VEC); p2[2]=(long)arch;
  for (k=1; k<lg(fa2); k++)
  {
    pr=(GEN)fa2[k]; ep=itos((GEN)ex[k]); flfin=1;
    for (j=1; (j<=ep)&&flfin; j++)
    {
      p2[1]=(long)idealdiv(nf,ideal,pr);
      if (trivial) clhss=itos(rayclassno(bnf,p2));
      else
      {
	bnr2=buchrayall(bnf,p2,0,prec);
	clhss=itos(cardofimagofquotientgroup(generator,bnr2,subgroup));
      }
      if (clhss==clhray) ideal=(GEN)p2[1];
      else flfin=0;
    }
  }
  p2[1]=(long)ideal; arch2=gcopy(arch); p2[2]=(long)arch2;
  for (k=1; k<=r1; k++)
  {
    if (signe(arch[k]))
    {
      arch2[k]=zero;
      if (trivial) clhss=itos(rayclassno(bnf,p2));
      else
      {
	bnr2=buchrayall(bnf,p2,0,prec);
	clhss=itos(cardofimagofquotientgroup(generator,bnr2,subgroup));
      }
      if (clhss!=clhray) arch2[k]=un;
    }
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(p2));
}

static GEN
discrayrelall(GEN bnr,GEN subgroup,long flag,long flrel,long prec)
/*
 *   Etant donnes un corps de nombres bnf=bnr[1], un groupe de classes de rayon
 * bnr calcule par buchrayinit(), et une matrice HNF subgroup definissant un
 * sous-groupe du groupe de classes de rayon, calcule [n,r1,dk] associe a ce
 * sous groupe (cf. discrayall()).  flcond a le meme usage que dans
 * discrayall; si flag=0 le calcul est arrete si le module n'est pas le
 * conducteur et le programme retourne gzero.  Si flrel=0, seul la norme de
 * l'ideal dk est calculee au lieu de dk lui-meme
 */
{
  long r1,degk,j,av=avma,tetpil,k,clhray,clhss,ep,som,nbdezero;
  long trivial=0;
  GEN bnf,nf,classgroup,cyclic,generator,bid,module,ideal,arch,D,p1,p2;
  GEN fa,pr,dlk,arch2,bnr2,idealrel,fa2,ex;

  checkbnrgen(bnr); bnf=(GEN)bnr[1];
  classgroup=(GEN)bnr[5]; cyclic=(GEN)classgroup[2];
  generator=(GEN)classgroup[3];
  nf=(GEN)bnf[7]; r1=itos((GEN)((GEN)nf[2])[1]);
  degk=lgef(nf[1])-3;
  bid=(GEN)bnr[2]; module=(GEN)bid[1];
  ideal=(GEN)module[1]; arch=(GEN)module[2];
  D=diagonal(cyclic);
  if (gcmp0(subgroup)){ trivial=1; clhray=itos((GEN)classgroup[1]); }
  else
  {
    if (!gcmp1(denom(p1=invmulmat(subgroup,D))))
      err(talker,"incorrect subgroup in discray");
    clhray=itos(det(subgroup));
    if (gcmp1(det(p1))) trivial=1;
  }
  fa=(GEN)bid[3]; fa2=(GEN)fa[1]; ex=(GEN)fa[2];
  idealrel=flrel?idmat(degk):gun;
  p2=cgetg(3,t_VEC); p2[2]=(long)arch;
  for (k=1; k<lg(fa2); k++)
  {
    pr=(GEN)fa2[k]; ep=itos((GEN)ex[k]); p2[1]=lcopy(ideal); som=0; clhss=0;
    for (j=1; j<=ep; j++)
    {
      if (clhss==1) som++;
      else
      {
	p2[1]=(long)idealdiv(nf,(GEN)p2[1],pr);
	if (trivial) clhss=itos(rayclassno(bnf,p2));
	else
	{
	  bnr2=buchrayall(bnf,p2,0,prec);
	  clhss=itos(cardofimagofquotientgroup(generator,bnr2,subgroup));
	}
	if ((j==1)&&(clhss==clhray)&&(!flag)){ avma=av; return gzero; }
	som+=clhss;
      }
    }
    idealrel=flrel?idealmul(nf,idealrel,idealpow(nf,pr,stoi(som))):
      mulii(idealrel,gpui((GEN)pr[1],mulsi(som,(GEN)pr[4]),0));
  }
  dlk=flrel?idealdiv(nf,idealpow(nf,ideal,stoi(clhray)),idealrel):
    divii(gpuigs(dethnf(ideal),clhray),idealrel);
  p2[1]=(long)ideal; arch2=gcopy(arch); p2[2]=(long)arch2; nbdezero=0;
  for (k=1; k<=r1; k++)
  {
    if (signe(arch[k]))
    {
      arch2[k]=zero;
      if (trivial) clhss=itos(rayclassno(bnf,p2));
      else
      {
	bnr2=buchrayall(bnf,p2,0,prec);
	clhss=itos(cardofimagofquotientgroup(generator,bnr2,subgroup));
      }
      arch2[k]=un;
      if (clhss==clhray) nbdezero++;
      if ((clhss==clhray)&&(!flag)){ avma=av; return gzero; }
    }
    else nbdezero++;
  }
  tetpil=avma; p1=cgetg(4,t_VEC); p1[1]=lstoi(clhray); p1[2]=lstoi(nbdezero);
  p1[3]=lcopy(dlk); return gerepile(av,tetpil,p1);
}

GEN
discray0(GEN arg0, GEN arg1, GEN arg2, long flag, long prec)
{
  long rel=flag &1, cond=(flag &2)?0:1;
  long av=avma,tetpil,degk,clhray,n,nbdezero,R1;
  GEN p1,p2,p3,p4,nf,dkabs,bnr,bnf,subgroup=arg1;

  bnr=args_to_bnr(arg0,arg1,arg2,&subgroup,prec);
  bnf=(GEN) bnr[1];
  p1=discrayrelall(bnr,subgroup,cond,rel,prec);

  if (rel) return p1;

  if (gcmp0(p1)) { avma=av; return gzero; }
  bnf=(GEN)bnr[1]; nf=(GEN)bnf[7];
  degk=lgef(nf[1])-3; dkabs=gabs((GEN)nf[3],0);
  p2=(GEN)p1[3]; clhray=itos((GEN)p1[1]); p3=gpuigs(dkabs,clhray);
  n=clhray*degk; nbdezero=itos((GEN)p1[2]); R1=nbdezero*clhray;
  if (((n-R1)&3)==2) p2=negi(p2);
  tetpil=avma; p4=cgetg(4,t_VEC); p4[1]=lstoi(n);
  p4[2]=lstoi(R1); p4[3]=lmul(p2,p3);
  return gerepile(av,tetpil,p4);
}

GEN
discrayrel(GEN bnr, GEN subgroup,long prec)
{
  return discrayrelall(bnr,subgroup,1,1,prec);
}

GEN
discrayrelcond(GEN bnr, GEN subgroup,long prec)
{
  return discrayrelall(bnr,subgroup,0,1,prec);
}

static GEN
discrayabsall(GEN bnr, GEN subgroup,long flag,long prec)
{
  long av=avma,tetpil,degk,clhray,n,nbdezero,R1;
  GEN p1,p2,p3,p4,nf,dkabs,bnf;

  p1=discrayrelall(bnr,subgroup,flag,0,prec);
  if (gcmp0(p1)) { avma=av; return gzero; }
  bnf=(GEN)bnr[1]; nf=(GEN)bnf[7]; degk=lgef(nf[1])-3; dkabs=gabs((GEN)nf[3],0);
  p2=(GEN)p1[3]; clhray=itos((GEN)p1[1]); p3=gpuigs(dkabs,clhray);
  n=clhray*degk; nbdezero=itos((GEN)p1[2]); R1=nbdezero*clhray;
  if (((n-R1)&3)==2) p2=negi(p2);
  tetpil=avma; p4=cgetg(4,t_VEC); p4[1]=lstoi(n);
  p4[2]=lstoi(R1); p4[3]=lmul(p2,p3);
  return gerepile(av,tetpil,p4);
}

GEN
discrayabs(GEN bnr, GEN subgroup,long prec)
{
  return discrayabsall(bnr,subgroup,1,prec);
}

GEN
discrayabscond(GEN bnr, GEN subgroup,long prec)
{
  return discrayabsall(bnr,subgroup,0,prec);
}

static GEN
trouveralpha(GEN nf,GEN x,GEN ideal,long prec)
/* etant donnes un ideal entier x et un ideal ideal premiers entre eux, calcule
   un alpha appartenant a x et congru a 1 mod ideal avec x/alpha presque
   reduit. A usage interne, pas de verifs ni pile. */
{
  GEN alp,idprod,y,T2,p1;

  T2=(GEN)((GEN)nf[5])[3]; idprod=idealmullll(nf,x,ideal);
  y=gmul(idprod,(GEN)(lllgram(gmul(gtrans(idprod),gmul(T2,idprod)),2*prec-2)[1]));
  alp=(GEN)idealaddone(nf,x,ideal)[1];
  p1=ground(element_div(nf,alp,y));
  alp=gsub(alp,element_mul(nf,p1,y));
  if (gcmp0(alp)) alp=y;
  return alp;
}

static GEN
ideallllredmodidealall(GEN nf,GEN x,GEN ideal,long prec)
{
/* etant donnes un ideal x et un ideal ideal premiers entre eux, calcule beta
 utilise ci-dessous */

  long fl;
  GEN alp,bet,p1;

  nf=checknf(nf);
  alp=trouveralpha(nf,x,ideal,prec);
  p1=idealdiv(nf,alp,x);
  bet=element_div(nf,trouveralpha(nf,p1,ideal,prec),alp);
  fl=(gcmpgs(gabs(gnorm(basistoalg(nf,bet)),0),1)>0);
  if (fl) return gzero; else return bet;
}

static GEN
ideallllredmodideal(GEN nf,GEN x,GEN ideal,long prec)
{
/* etant donnes un ideal x et un ideal ideal premiers entre eux, calcule un ideal
   entier de la forme beta*x avec beta congru a 1 mod ideal et beta*x presque reduit */

  long av=avma,tetpil;
  GEN bet;

  bet=ideallllredmodidealall(nf,x,ideal,prec);
  if (gcmp0(bet)) { avma=av; return gcopy(x); }
  tetpil=avma; return gerepile(av,tetpil,idealmul(nf,bet,x));
}

static GEN
idealpowmodideal(GEN nf,GEN x,GEN k,GEN ideal,long prec)
{
  long av=avma,tetpil,f,N;
  GEN k1,y,z;

  N=lgef(nf[1])-3; k1=k; z=x; f=1; tetpil=avma; y=idmat(N);
  while (f)
  {
    if (mpodd(k1)) { tetpil=avma; y=idealmulmodideal(nf,z,y,ideal,prec); }
    k1=shifti(k1,-1); f=signe(k1);
    if (f) z=idealmulmodideal(nf,z,z,ideal,prec);
  }
  return gerepile(av,tetpil,y);
}

static GEN
idealmodidele(GEN nf, GEN z, GEN module, GEN structarch, GEN arch, long nba, long prec)
{
  long av=avma,tetpil,fl,i;
  GEN p1,p2,bet;

  nf=checknf(nf);
  bet=ideallllredmodidealall(nf,z,(GEN)module[1],prec);
  if (gcmp0(bet)){ tetpil=avma; return gerepile(av,tetpil,gcopy(z)); }
  p1=(GEN)structarch[2];
  p2=lift(gmul((GEN)structarch[3],zsigne(nf,bet,arch,nba)));
  for (i=1; i<lg(p2); i++)
    if (signe(p2[i])) bet=element_mul(nf,bet,(GEN)p1[i]);
  fl=(gcmpgs(gabs(gnorm(basistoalg(nf,bet)),0),1)>0);
  tetpil=avma;
  if (fl) return gerepile(av,tetpil,gcopy(z));
  return gerepile(av,tetpil,idealmul(nf,bet,z));
}

static GEN
idealmulmodidele(GEN nf, GEN x, GEN y, GEN module, GEN structarch, GEN arch, long nba, long prec)
{
  long av=avma,tetpil;
  GEN z;

  nf=checknf(nf); z=idealmul(nf,x,y); tetpil=avma;
  return gerepile(av,tetpil,idealmodidele(nf,z,module,structarch,arch,nba,prec));
}

static GEN
idealpowmodidele(GEN nf,GEN x,GEN k,GEN module, GEN structarch, GEN arch, long nba, long prec)
{
  long av=avma,tetpil;
  GEN k1,p1;

  k1=shifti(k,-1);
  p1=idealpowmodideal(nf,x,k1,(GEN)module[1],prec);
  tetpil=avma; p1=idealmulmodideal(nf,p1,p1,(GEN)module[1],prec);
  if (mpodd(k))
  {
    tetpil=avma;
    return gerepile(av,tetpil,idealmulmodidele(nf,p1,x,module,structarch,arch,nba,prec));
  }
  return gerepile(av,tetpil,p1);
}

GEN
bnfconductorofchar(GEN bnr,GEN chi,long prec)
/* Etant donnes un corps de nombres bnf=bnr[1], un groupe de classes de rayon
   bnr calcule par buchrayinit(), et un vecteur chi representant un caractere
   sur les generateurs bnr[2][3], calcule le conducteur de ce caractere.
   */
{
  long nbgen,i,j,av=avma,tetpil;
  GEN p1,p2,m,u,bigu,d1,classgroup,cyclic;

  checkbnrgen(bnr);
  classgroup=(GEN)bnr[5]; cyclic=(GEN)classgroup[2]; nbgen=lg(cyclic)-1;
  if ((lg(chi)-1)!=nbgen)
    err(talker,"incorrect character length in conductorofchar");
  if (!nbgen) return conductor(bnr,gzero,prec);
  d1=(GEN)cyclic[1];
  m=cgetg(nbgen+2,t_MAT);
  for (j=1; j<=nbgen; j++)
  {
    p1=cgetg(2,t_COL); m[j]=(long)p1;
    p1[1]=(long)gdiv(gmul((GEN)chi[j],d1),(GEN)cyclic[j]);
    if (typ(p1[1])!=t_INT) err(talker,"incorrect type in conductorofchar");
  }
  p1=cgetg(2,t_COL); m[nbgen+1]=(long)p1; p1[1]=(long)d1;
  bigu=(GEN)hnfall(m)[2];
  u=cgetg(nbgen+1,t_MAT);
  for (j=1; j<=nbgen; j++)
  {
    p1=cgetg(nbgen+1,t_COL); u[j]=(long)p1; p2=(GEN)bigu[j];
    for (i=1; i<=nbgen; i++) p1[i]=p2[i];
  }
  tetpil=avma; return gerepile(av,tetpil,conductor(bnr,u,prec));
}

#if 0
static GEN
cond_of_char(GEN bnr,GEN chi,long prec) /* calcul du conducteur du caractere chi */
{
  long av=avma,tetpil,fl,j,k,ex,jc,jl,l,lnew,exk;
  GEN p1,br,bid,bid1,bid3,modul,arch,factofmodul,expoofmodul,condarch,cond,condarchnew;
  GEN bnf,bnrnew,condnew,brnew,eij,cmat,gx,matred,matred2,u,pr;

  checkbnrgen(bnr); bnf=(GEN)bnr[1];
  br=(GEN)bnr[5]; bid=(GEN)bnr[2]; bid1=(GEN)bid[1]; modul=(GEN)bid1[1]; arch=(GEN)bid1[2];
  bid3=(GEN)bid[3]; factofmodul=(GEN)bid3[1]; expoofmodul=(GEN)bid3[2];
  if (lg(chi)!=lg(br[2])){ printf("longueur incorrecte\n"); exit(1); }
  condarch=gcopy(arch); cond=gcopy(modul);
  for (k=1; k<lg(arch); k++)
  {
    if (signe(arch[k]))
    {
      condarchnew=condarch; condarchnew[k]=zero;
      p1=cgetg(3,t_VEC); p1[1]=(long)cond; p1[2]=(long)condarchnew;
      bnrnew=buchrayinitgen(bnf,p1,prec); brnew=(GEN)bnrnew[5];
      lnew=lg(brnew[2])-1; l=lg(br[2])-1; eij=cgetg(l+1,t_MAT);
      if (l)
      {
	for (j=1; j<=l; j++) eij[j]=(long)isprincipalray(bnrnew,(GEN)((GEN)br[3])[j]);
	cmat=cgetg(lnew+l+1,t_MAT);
	for (jc=1; jc<=lnew; jc++)
	{
	  p1=cgetg(l+1,t_COL); cmat[jc]=(long)p1;
	  for (jl=1; jl<=l; jl++)
	    p1[jl]=(long)divii(mulii(gcoeff(eij,jc,jl),(GEN)((GEN)br[2])[jl]),
			       (GEN)((GEN)brnew[2])[jc]);
	}
	for (jc=lnew+1; jc<=lnew+l; jc++)
	{
	  p1=cgetg(l+1,t_COL); cmat[jc]=(long)p1;
	  for (jl=1; jl<=l; jl++) p1[jl]=(jl==(jc-lnew))?((GEN)br[2])[jl]:zero;
	}
	matred2=hnfall(cmat); matred=(GEN)matred2[1]; gx=gauss(matred,chi);
	fl=gcmp1(denom(gx));
	if (fl)
	{
	  condarch=condarchnew; bnr=bnrnew; br=(GEN)bnr[5]; u=(GEN)matred2[2];
	  if (lnew)
	  { chi=cgetg(l+1,t_MAT); for (jc=1; jc<=l; jc++)chi[jc]=u[jc+lnew]; chi=gmul(chi,gx); }
	  else chi=cgetg(1,t_COL);
	}
      }
      else{ condarch=condarchnew; bnr=bnrnew; br=(GEN)bnr[5]; chi=cgetg(1,t_COL); }
    }
  }
  for (k=1; k<lg(factofmodul); k++)
  {
    fl=1; ex=1; exk=itos((GEN)expoofmodul[k]);
    while (fl&&(ex<=exk))
    {
      pr=(GEN)factofmodul[k]; ex++;
      condnew=idealdiv(bnf,cond,pr);
      p1=cgetg(3,t_VEC); p1[1]=(long)condnew; p1[2]=(long)condarch;
      bnrnew=buchrayinitgen(bnf,p1,prec);
      brnew=(GEN)bnrnew[5];
      lnew=lg(brnew[2])-1; l=lg(br[2])-1;
      eij=cgetg(l+1,t_MAT);
      if (l)
      {
	for (j=1; j<=l; j++)
	  eij[j]=(long)isprincipalray(bnrnew,(gmael(br,3,j)));
	cmat=cgetg(lnew+l+1,t_MAT);
	for (jc=1; jc<=lnew; jc++)
	{
	  p1=cgetg(l+1,t_COL); cmat[jc]=(long)p1;
	  for (jl=1; jl<=l; jl++)
	    p1[jl]=(long)divii(mulii(gcoeff(eij,jc,jl),(GEN)((GEN)br[2])[jl]),
			       (GEN)((GEN)brnew[2])[jc]);
	}
	for (jc=lnew+1; jc<=lnew+l; jc++)
	{
	  p1=cgetg(l+1,t_COL); cmat[jc]=(long)p1;
	  for (jl=1; jl<=l; jl++) p1[jl]=(jl==(jc-lnew))?((GEN)br[2])[jl]:zero;
	}
	matred2=hnfall(cmat); matred=(GEN)matred2[1]; gx=gauss(matred,chi);
	fl=gcmp1(denom(gx));
	if (fl)
	{
	  cond=condnew; bnr=bnrnew; br=(GEN)bnr[5]; u=(GEN)matred2[2];
	  if (lnew)
	  { chi=cgetg(l+1,t_MAT); for (jc=1; jc<=l; jc++)chi[jc]=u[jc+lnew]; chi=gmul(chi,gx); }
	  else chi=cgetg(1,t_COL);
	}
      }
      else{ fl=1; cond=condnew; bnr=bnrnew; br=(GEN)bnr[5]; chi=cgetg(1,t_COL); }
    }
  }
  tetpil=avma; p1=cgetg(3,t_VEC); p1[1]=lcopy(cond); p1[2]=lcopy(condarch);
  return gerepile(av,tetpil,p1);
}
#endif

GEN
rayclassnolist(GEN bnf,GEN listes)
/* Etant donne la liste des zidealstarinit et des matrices d'unites
 * correspondantes, sort la liste des nombres de classes
 */
{
  long av=avma,tetpil,i,j,k,kk,nc,nq,lx,ly;
  GEN h,modulist,unitlist,classlist,sous,sousu,sousclass,p2,m,bid,q,cyclic;

  checkbnf(bnf);
  if (typ(listes)!=t_VEC || lg(listes)!=3)
    err(talker,"incorrect type in rayclassnolist");
  h=(GEN)((GEN)((GEN)bnf[8])[1])[1];
  modulist=(GEN)listes[1]; unitlist=(GEN)listes[2]; lx=lg(modulist);
  classlist=cgetg(lx,t_VEC);
  for (i=1; i<lx; i++)
  {
    sous=(GEN)modulist[i]; sousu=(GEN)unitlist[i]; ly=lg(sous);
    sousclass=cgetg(ly,t_VEC); classlist[i]=(long)sousclass;
    for (j=1; j<ly; j++)
    {
      bid=(GEN)sous[j];
      q=(GEN)sousu[j]; nq=lg(q)-1;
      cyclic=(GEN)((GEN)bid[2])[2]; nc=lg(cyclic)-1;
      if (lg(q[1])!=(nc+1)) err(talker,"bug in rayclassnolist");
      m=cgetg(nq+nc+1,t_MAT);
      for (k=1; k<=nq; k++) m[k]=q[k];
      for (; k<=nq+nc; k++)
      {
	p2=cgetg(nc+1,t_COL); m[k]=(long)p2;
	for (kk=1; kk<=nc; kk++) p2[kk]=(kk==k-nq)?cyclic[kk]:zero;
      }
      sousclass[j]=lmul(h,dethnf(hnf(m)));
    }
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(classlist));
}

static GEN
rayclassnolistes(GEN sous, GEN sousclass, GEN fac)
{
  long i;

  for (i=1; i<lg(sous); i++)
  {
    if (gegal(gmael(sous,i,3),fac))
      return (GEN)sousclass[i];
  }
  err(talker,"bug in discrayabslist");
  return NULL; /* not reached */
}

static GEN
rayclassnolistessimp(GEN sous, GEN fac)
{
  long i;

  for (i=1; i<lg(sous); i++)
  {
    if (gegal(gmael(sous,i,1),fac))
      return gmael(sous,i,2);
  }
  err(talker,"bug in discrayabslistlong");
  return NULL; /* not reached */
}

static GEN
factormul(GEN fa1,GEN fa2)
{
  long i,c,lx;
  GEN listpr,listprnew,listex,listexnew,v,p,y;

  listpr=concat((GEN)fa1[1],(GEN)fa2[1]);
  listex=concat((GEN)fa1[2],(GEN)fa2[2]);
  v=indexsort(listpr); lx=lg(listpr); listprnew=cgetg(lx,t_COL);
  for (i=1; i<lx; i++) listprnew[i]=listpr[itos((GEN)v[i])];
  listexnew=cgetg(lx,t_COL);
  for (i=1; i<lx; i++) listexnew[i]=listex[itos((GEN)v[i])];
  p=gzero;
  for (c=0,i=1; i<lx; i++)
  {
    if (gegal((GEN)listprnew[i],p))
      listex[c]=laddii((GEN)listex[c],(GEN)listexnew[i]);
    else
    {
      c++; p=(GEN)listprnew[i]; listpr[c]=(long)p; listex[c]=listexnew[i];
    }
  }
  y=cgetg(3,t_MAT); listprnew=cgetg(c+1,t_COL); listexnew=cgetg(c+1,t_COL);
  y[1]=(long)listprnew; y[2]=(long)listexnew;
  for (i=1; i<=c; i++) { listprnew[i]=listpr[i]; listexnew[i]=listex[i]; }
  return y;
}

static GEN
factordivexact(GEN fa1,GEN fa2)
{
  long i,j,k,c,lx1,lx2;
  GEN listpr,listprnew,listex,listexnew,y,listpr1,listex1,listpr2,listex2,p1;

  listpr1=(GEN)fa1[1]; listex1=(GEN)fa1[2]; lx1=lg(listpr1);
  listpr2=(GEN)fa2[1]; listex2=(GEN)fa2[2]; lx2=lg(listpr1);
  listpr=cgetg(lx1,t_COL); listex=cgetg(lx1,t_COL);
  for (c=0,i=1; i<lx1; i++)
  {
    j=isinvector(listpr2,(GEN)listpr1[i],lx2-1);
    if (!j) { c++; listpr[c]=listpr1[i]; listex[c]=listex1[i]; }
    else
    {
      p1=subii((GEN)listex1[i],(GEN)listex2[j]); k=signe(p1);
      if (k<0) err(talker,"factordivexact is not exact!");
      if (k>0) { c++; listpr[c]=listpr1[i]; listex[c]=(long)p1; }
    }
  }
  y=cgetg(3,t_MAT); listprnew=cgetg(c+1,t_COL); listexnew=cgetg(c+1,t_COL);
  y[1]=(long)listprnew; y[2]=(long)listexnew;
  for (i=1; i<=c; i++) { listprnew[i]=listpr[i]; listexnew[i]=listex[i]; }
  return y;
}

static GEN
factorpow(GEN fa,long n)
{
  GEN y=cgetg(3,t_MAT);

  if (!n) { y[1]=lgetg(1,t_COL); y[2]=lgetg(1,t_COL); return y; }
  y[1]=fa[1]; y[2]=lmulsg(n,(GEN)fa[2]); return y;
}

GEN
discrayabslist(GEN bnf,GEN listes)
/*    Etant donne la liste des zidealstarinit et des matrices d'unites
 * correspondantes, sort la liste des discrayabs. On ne garde pas les modules
 * qui ne sont pas des conducteurs
 */
{
  long av=avma,tetpil,ii,jj,i,j,k,clhss,ep,clhray,lx,ly,r1,som,degk,nbdezero;
  long n,R1,normps,normi,lfa2;
  GEN classlist,modulist,disclist,nf,dkabs,sous,sousclass,sousdisc;
  GEN bid,module,ideal,arch,fa,fa2,ex,idealrel,p1,p2,pr;
  GEN dlk,arch2,p3,fac,normp,fad,fad1,fad2,no1,no2;

  classlist=rayclassnolist(bnf,listes); lx=lg(classlist); modulist=(GEN)listes[1];
  disclist=cgetg(lx,t_VEC); nf=(GEN)bnf[7]; r1=itos((GEN)((GEN)nf[2])[1]);
  degk=lgef(nf[1])-3; dkabs=gabs((GEN)nf[3],0);
  for (ii=1; ii<lx; ii++)
  {
    sous=(GEN)modulist[ii]; sousclass=(GEN)classlist[ii];
    ly=lg(sous); sousdisc=cgetg(ly,t_VEC); disclist[ii]=(long)sousdisc;
    for (jj=1; jj<ly; jj++)
    {
      bid=(GEN)sous[jj]; clhray=itos((GEN)sousclass[jj]);
      module=(GEN)bid[1]; ideal=(GEN)module[1]; arch=(GEN)module[2];
      fa=(GEN)bid[3]; fa2=(GEN)fa[1]; ex=(GEN)fa[2]; fac=gcopy(fa);
      idealrel=cgetg(3,t_MAT); idealrel[1]=lgetg(1,t_COL); idealrel[2]=lgetg(1,t_COL);
      p2=cgetg(3,t_VEC); p2[2]=(long)arch; lfa2=lg(fa2);
      for (k=1; k<lfa2; k++)
      {
	pr=(GEN)fa2[k]; ep=itos((GEN)ex[k]);
	p2[1]=lcopy(ideal); som=0; clhss=0;
	normp=gpui((GEN)pr[1],(GEN)pr[4],0); normps=itos(normp); normi=ii;
	normp=cgetg(3,t_MAT); no1=cgetg(2,t_COL); no1[1]=pr[1]; normp[1]=(long)no1;
	no2=cgetg(2,t_COL); no2[1]=pr[4]; normp[2]=(long)no2;
	for (j=1; j<=ep; j++)
	{
	  if (clhss==1) som++;
	  else
	  {
	    if (j<ep) { coeff(fac,k,2)=lstoi(ep-j); fad=fac; }
	    else
	    {
	      fad=cgetg(3,t_MAT); fad1=cgetg(lfa2-1,t_COL); fad2=cgetg(lfa2-1,t_COL);
	      fad[1]=(long)fad1; fad[2]=(long)fad2;
	      for (i=1; i<k; i++) { fad1[i]=coeff(fac,i,1); fad2[i]=coeff(fac,i,2); }
	      for (; i<lfa2-1; i++) { fad1[i]=coeff(fac,i+1,1); fad2[i]=coeff(fac,i+1,2); }
	    }
	    normi/=normps;
	    clhss=itos(rayclassnolistes((GEN)modulist[normi],(GEN)classlist[normi],fad));
	    if ((j==1)&&(clhss==clhray)){ clhray=0; goto LDISCRAY; }
	    som+=clhss;
	  }
	}
	coeff(fac,k,2)=ex[k];
	idealrel=factormul(idealrel,factorpow(normp,som));
      }
      dlk=factordivexact(factorpow(factor(stoi(ii)),clhray),idealrel);
      p2[1]=(long)ideal; arch2=gcopy(arch); p2[2]=(long)arch2; nbdezero=0;
      for (k=1; k<=r1; k++)
      {
	if (signe(arch[k]))
	{
	  arch2[k]=zero;
	  clhss=itos(rayclassno(bnf,p2));
	  arch2[k]=un;
	  if ((clhss==clhray)){ clhray=0; goto LDISCRAY; }
	}
	else nbdezero++;
      }
      LDISCRAY:
      if (!clhray) sousdisc[jj]=lgetg(1,t_VEC);
      else
      {
	p3=factorpow(factor(dkabs),clhray); n=clhray*degk; R1=nbdezero*clhray;
	if (((n-R1)&3)==2)
	{
	  normp=cgetg(3,t_MAT); no1=cgetg(2,t_COL); normp[1]=(long)no1; no1[1]=lstoi(-1);
	  no2=cgetg(2,t_COL); normp[2]=(long)no2; no2[1]=un;
	  dlk=factormul(normp,dlk);
	}
	
	p1=cgetg(4,t_VEC); p1[1]=lstoi(n); p1[2]=lstoi(R1); p1[3]=(long)factormul(dlk,p3);
	sousdisc[jj]=(long)p1;
      }
    }
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(disclist));
}

#define SHLGVINT 15
#define LGVINT 32768 /* must be 1<<SHLGVINT */

static GEN
bigcgetvec(long bound)
/* Attention: bound est le nombre de vraies composantes voulues. */
{
  long nbcext,nbfinal,i;
  GEN vext;

  nbcext=((bound-1)>>SHLGVINT)+1; nbfinal=bound-((nbcext-1)<<SHLGVINT);
  vext=cgetg(nbcext+1,t_VEC);
  for (i=1; i<nbcext; i++) vext[i]=lgetg(LGVINT+1,t_VEC);
  vext[nbcext]=lgetg(nbfinal+1,t_VEC);
  return vext;
}

static GEN
getcompobig(GEN vext,long i)
{
  long cext;

  if (i<=LGVINT) return (GEN)((GEN)vext[1])[i];
  cext=((i-1)>>SHLGVINT)+1;
  return (GEN)((GEN)vext[cext])[i-((cext-1)<<SHLGVINT)];
}

static void
putcompobig(GEN vext,long i,GEN x)
{
  long cext;

  if (i<=LGVINT) { ((GEN)vext[1])[i]=(long)x; return; }
  cext=((i-1)>>SHLGVINT)+1; ((GEN)vext[cext])[i-((cext-1)<<SHLGVINT)]=(long)x;
  return;
}

static GEN
zsimp(GEN bid, GEN matunit)
{
  GEN y;

  y=cgetg(5,t_VEC); y[1]=lcopy((GEN)bid[3]); y[2]=lcopy((GEN)((GEN)bid[2])[2]);
  y[3]=lcopy((GEN)bid[5]); y[4]=lcopy(matunit); return y;
}

#if 0
static GEN
zsimpjoin1(GEN bidp, GEN faussefa, GEN matunit)
{
  GEN y;

  y=cgetg(5,t_VEC); y[1]=(long)faussefa; y[2]=((GEN)bidp[2])[2];
  y[3]=bidp[5]; y[4]=(long)matunit; return y;
}
#endif

static GEN
zsimpjoin(GEN bidsimp, GEN bidp, GEN faussefa, GEN matunit)
{
  long i,j,lx,lx1,lx2,llx,llx1,llx2,nbgen,av=avma,tetpil,c;
  GEN y,U1,U2,cyclic1,cyclic2,U,cyc,u1u2,p1,p2,met;

  y=cgetg(5,t_VEC); y[1]=(long)vconcat((GEN)bidsimp[1],faussefa);
  U1=(GEN)bidsimp[3]; U2=(GEN)bidp[5]; cyclic1=(GEN)bidsimp[2];
  cyclic2=(GEN)((GEN)bidp[2])[2]; lx1=lg(U1); lx2=lg(U2); lx=lx1+lx2-1;
  llx1=lg(cyclic1); llx2=lg(cyclic2);
  llx=llx1+llx2-1; nbgen=llx-1;
  if (nbgen)
  {
    cyc=diagonal(concat(cyclic1,cyclic2));
    u1u2=smithclean(smith2(cyc)); met=(GEN)u1u2[3]; c=lg(met)-1;
    U=cgetg(lx,t_MAT);
    for (j=1; j<lx1; j++)
    {
      p1=cgetg(llx,t_COL); p2=(GEN)U1[j]; U[j]=(long)p1;
      for (i=1; i<llx1; i++) p1[i]=p2[i];
      for (; i<llx; i++) p1[i]=zero;
    }
    for (; j<lx; j++)
    {
      p1=cgetg(llx,t_COL); p2=(GEN)U2[j-lx1+1]; U[j]=(long)p1;
      for (i=1; i<llx1; i++) p1[i]=zero;
      for (; i<llx; i++) p1[i]=p2[i-llx1+1];
    }
    y[3]=lmul((GEN)u1u2[1],U);
  }
  else
  {
    met=cgetg(1,t_MAT); U=cgetg(lx,t_MAT); for (j=1; j<lx; j++) U[j]=lgetg(1,t_COL);
    y[3]=(long)U; c=0;
  }
  cyc=cgetg(c+1,t_VEC); for (i=1; i<=c; i++) cyc[i]=coeff(met,i,i);
  y[2]=(long)cyc;
  y[4]=(long)vconcat((GEN)bidsimp[4],matunit);
  tetpil=avma; return gerepile(av,tetpil,gcopy(y));
}

static GEN
rayclassnointern(GEN sous, GEN clh)
{
  long lx,nc,nq,k,kk,j;
  GEN bidsimp,qm,sousray,cyclic,m,p2,p1;

  lx=lg(sous); sousray=cgetg(lx,t_VEC);
  for (j=1; j<lx; j++)
  {
    bidsimp=(GEN)sous[j]; qm=gmul((GEN)bidsimp[3],(GEN)bidsimp[4]);
    nq=lg(qm)-1; cyclic=(GEN)bidsimp[2]; nc=lg(cyclic)-1;
    if (lg(qm[1])!=(nc+1)) err(talker,"bug in rayclassnolist");
    m=cgetg(nq+nc+1,t_MAT);
    for (k=1; k<=nq; k++) m[k]=qm[k];
    for (; k<=nq+nc; k++)
    {
      p2=cgetg(nc+1,t_COL); m[k]=(long)p2;
      for (kk=1; kk<=nc; kk++) p2[kk]=(kk==k-nq)?cyclic[kk]:zero;
    }
    p1=cgetg(3,t_VEC); p1[2]=lmul(clh,dethnf(hnf(m)));
    p1[1]=bidsimp[1]; sousray[j]=(long)p1;
  }
  return sousray;
}

static GEN
rayclassnointernarch(GEN sous, GEN clh, GEN matarchunit)
{
  long lx,nc,nq,k,kk,j,lm,lh,r1,jj,i,nba,nbarch,ii;
  GEN bidsimp,qm,sousray,cyclic,m,p2,p1,p1all,p3,mm,mj,qmk,matk;

  lm=lg(matarchunit); if (!lm) err(talker,"no units in rayclassnointernarch");
  r1=lg(matarchunit[1])-1;
  lx=lg(sous); sousray=cgetg(lx,t_VEC);
  for (j=1; j<lx; j++)
  {
    bidsimp=(GEN)sous[j]; qm=gmul((GEN)bidsimp[3],(GEN)bidsimp[4]);
    nq=lg(qm)-1; if (lm!=nq+1) err(talker,"bug 1 in rayclassnointernarch");
    cyclic=(GEN)bidsimp[2]; nc=lg(cyclic)-1;
    if (lg(qm[1])!=(nc+1)) err(talker,"bug 2 in rayclassnointernarch");
    m=cgetg(nq+nc+r1+1,t_MAT);
    for (k=1; k<=nq; k++)
    {
      p2=cgetg(nc+r1+1,t_COL); m[k]=(long)p2; qmk=(GEN)qm[k];
      matk=(GEN)matarchunit[k];
      for (kk=1; kk<=nc; kk++) p2[kk]=qmk[kk];
      for (; kk<=nc+r1; kk++) p2[kk]=matk[kk-nc];
    }
    for (; k<=nq+nc; k++)
    {
      p2=cgetg(nc+r1+1,t_COL); m[k]=(long)p2;
      for (kk=1; kk<=nc+r1; kk++) p2[kk]=(kk==k-nq)?cyclic[kk]:zero;
    }
    for (; k<=nq+nc+r1; k++)
    {
      p2=cgetg(nc+r1+1,t_COL); m[k]=(long)p2;
      for (kk=1; kk<=nc+r1; kk++) p2[kk]=(kk==k-nq)?deux:zero;
    }
    m=hnf(m); if (r1>15) err(talker,"r1>15 in rayclassnointernarch");
    nbarch=(1<<r1); p1all=cgetg(nbarch+1,t_VEC); lh=lg(m);
    if (lh!=nc+r1+1) err(talker,"bug 3 in rayclassnointernarch");
    for (k=0; k<=nbarch-1; k++)
    {
      p2=cgetg(r1+1,t_COL); kk=k; nba=0;
      for (jj=1; jj<=r1; jj++)
      {
	if (kk%2) { nba++; p2[jj]=un; } else p2[jj]=zero;
	kk>>=1;
      }
      mm=cgetg(lh,t_MAT);
      for (jj=1; jj<lh; jj++)
      {
	p3=cgetg(nc+nba+1,t_COL); mm[jj]=(long)p3; mj=(GEN)m[jj];
	for (i=1; i<=nc; i++) p3[i]=mj[i];
	for (ii=1; ii<=r1; ii++)
	if (signe(p2[ii])) p3[i++]=mj[nc+ii];
      }
      p1all[k+1]=lmul(clh,dethnf(hnf(mm)));
    }
    p1=cgetg(3,t_VEC); p1[2]=(long)p1all; p1[1]=bidsimp[1];
    sousray[j]=(long)p1;
  }
  return sousray;
}

GEN
discrayabslistarch(GEN bnf, GEN arch, long bound)
/*
 *    Fait tout a partir du debut, et bound peut aller jusqu'a 2^30. Pour
 * l'instant ne s'occupe pas des sous-groupes.   le format de sortie est le
 * suivant: un vecteur vext dont les composantes vint ont exactement 2^LGVINT
 * vraies composantes sauf le dernier qui peut etre plus court. vext[i][j]
 * (ou j<=2^LGVINT) doit etre compris comme la composante d'indice
 * I=(i-1)*2^LGVINT+j d'un grand vecteur unique V.  Une telle composante
 * d'indice I est un vecteur indexe par tous les ideaux de norme egal a I. Si
 * m_0 est un tel ideal, la composante correspondante est la suivante:
 * [m_0,arch,N,R1,D], ou N, R1, D sont comme dans discrayabs sauf que D est
 * sous  forme factorisee.
 */
{
  byteptr ptdif=diffptr;
  long diff,prime=0,degk,lim,av0,av,av1,tetpil,i,j,k,p2s,lfa,lp1,sqbou,cex;
  long ffs,fs,resp,flbou,tdi,nba;
  uLong q;
  long ii,jj,ly,clhray,lfa2,ep,som,clhss,normps,normi,nbdezero,r1,R1,n,lp4,c;
  GEN nf,p,z,pol,p1,p2,p3,fa,pr,normp,ideal,bidp,z2,pourz1,vraipr;
  GEN bigres,funits,racunit,embunit,sous,clh,sousray,raylist;
  GEN sousdisc,module,fa2,ex,fac,no1,no2,fad,fad1,fad2,dkabs,pz;
  GEN idealrel,arch2,dlk,disclist,bidsimp,p4,faussefa,pex,fauxpr,gprime;
  GEN *gptr[2];

/* ce qui suit recopie d'assez pres ideallistzstarall */

  if (DEBUGLEVEL) timer2();
  av0=avma; checkbnf(bnf); flbou=0;
  nf=(GEN)bnf[7]; bigres=(GEN)bnf[8]; pol=(GEN)nf[1]; degk=lgef(pol)-3;
  r1=itos((GEN)((GEN)nf[2])[1]); dkabs=gabs((GEN)nf[3],0);
  clh=(GEN)((GEN)bigres[1])[1];
  if ((arch==(GEN)0)||(gcmp0(arch)))
    { arch=cgetg(r1+1,t_VEC); for (i=1; i<=r1; i++) arch[i]=zero; }
  if (lg(arch)!=r1+1)
    err(talker,"incorrect archimedean argument in discrayabslistlong");
  if (lg(bigres)!=5)
  {
    if (lg(bigres)!=7) err(talker,"incorrect big number field");
    else funits=(GEN)bigres[5];
  }
  else funits=(GEN)buchfu(bnf)[1];
  racunit=(GEN)((GEN)bigres[4])[2];
  p=cgeti(3); p[1]=evalsigne(1)+evallgef(3);
  sqbou=itos(racine(stoi(bound)))+1;
  for (nba=0,i=1; i<=r1; i++) if (signe(arch[i])) nba++;
  av=avma; lim=(bot+avma)>>1;
  z=bigcgetvec(bound); for (i=2; i<=bound; i++) putcompobig(z,i,cgetg(1,t_VEC));
  pourz1=cgetg(3,t_VEC); pourz1[1]=(long)idmat(degk); pourz1[2]=(long)arch;
  bidp=zidealstarinitall(nf,pourz1,0);
  embunit=logunitmatrix(nf,funits,racunit,bidp);
  p1=cgetg(2,t_VEC); putcompobig(z,1,p1); p1[1]=(long)zsimp(bidp,embunit);
  diff= *ptdif++; prime+=diff; if (!diff) err(primer1);
  if (DEBUGLEVEL) fprintferr("Starting zidealstarunits computations\n");
  do
  {
    p[2]=prime;
    if ((!flbou)&&(prime>sqbou))
    {
      flbou=1;
      if (DEBUGLEVEL)
      { fprintferr("\nStarting rayclassno computations\n"); flusherr(); }
      tetpil=avma; z=gerepile(av,tetpil,gcopy(z));
      av1=avma; raylist=bigcgetvec(bound);
      /* maintenant on suit rayclassnolist */
      for (i=1; i<=bound; i++)
      {
	sous=getcompobig(z,i); sousray=rayclassnointern(sous,clh);
	putcompobig(raylist,i,sousray);
      }
      tetpil=avma; raylist=gerepile(av1,tetpil,gcopy(raylist));
      z2=bigcgetvec(sqbou);
      for (i=1; i<=sqbou; i++) { p1=gcopy(getcompobig(z,i)); putcompobig(z2,i,p1); }
      z=z2;
    }
    pari_randseed=1; fa=primedec(nf,p); lfa=lg(fa)-1;
    if (flbou&&(lfa==2)&&(degk==2)) lfa=1;
    for (j=1; j<=lfa; j++)
    {
      pr=(GEN)fa[j];
      if (DEBUGLEVEL) { fprintferr("%ld ",prime); flusherr(); }
      normp=gpui(p,(GEN)pr[4],0); cex=0;
      if (gcmpgs(normp,bound)<=0)
      {
	fauxpr=stoi(prime*degk*degk+(itos((GEN)pr[4])-1)*degk+j-1);
	q=p2s=itos(normp); ideal=pr;
	while ((uLong)q<=(uLong)bound)
	{
	  bidp=zidealstarinitall(nf,ideal,0);
	  faussefa=cgetg(3,t_MAT); p1=cgetg(2,t_COL);
	  faussefa[1]=(long)p1; p1[1]=(long)fauxpr;
	  pex=cgetg(2,t_COL); faussefa[2]=(long)pex;
	  cex++; pex[1]=lstoi(cex);
	  embunit=logunitmatrix(nf,funits,racunit,bidp);
	  for (i=q; i<=bound; i+=q)
	  {
	    p1=getcompobig(z,i/q); lp1=lg(p1);
	    if (lp1>1)
	    {
	      p2=cgetg(lp1,t_VEC); c=0;
	      for (k=1; k<lp1; k++)
	      {
		p3=(GEN)p1[k]; if (i>q) { p4=(GEN)((GEN)p3[1])[1]; lp4=lg(p4)-1; }
		if ((i==q)||(!isinvector(p4,fauxpr,lp4)))
		{
		  c++;
/*		  if (i==q) p2[c]=(long)zsimpjoin1(bidp,faussefa,embunit);
		  else */
		  p2[c]=(long)zsimpjoin(p3,bidp,faussefa,embunit);
		}
	      }
	      p3=cgetg(c+1,t_VEC); for (k=1; k<=c; k++) p3[k]=p2[k]; p2=p3;
	      if (c)
	      {
		if (prime<=sqbou)
		{
		  pz=getcompobig(z,i);
		  if (lg(pz)>1) putcompobig(z,i,concat(pz,p2));
		  else putcompobig(z,i,p2);
		}
		else
		{
		  sousray=rayclassnointern(p2,clh); 		
		  putcompobig(raylist,i,sousray);
		}
	      }
	    }
	  }
	  pz=mulss(q,p2s);
	  q=(gcmpgs(pz,bound)>0)?bound+1:pz[2];
	  if ((uLong)q<=(uLong)bound) ideal=idealmul(nf,ideal,pr);
	}
      }
    }
    diff= *ptdif++; prime+=diff; if (!diff) err(primer1);
    if (avma<lim)
    {
      tetpil=avma;
      if (!flbou)
      {
	if (DEBUGLEVEL)
	{ fprintferr("avma = %ld, t(z) = %ld ",avma-bot,taille2(z)); flusherr(); }
	z=gerepile(av,tetpil,gcopy(z));
      }
      else
      {
	if (DEBUGLEVEL)
	{ 
	  fprintferr("avma = %ld, t(r) = %ld ",avma-bot,taille2(raylist));
	  flusherr();
	}
	gptr[0]=&z; gptr[1]=&raylist;
	gerepilemany(av,gptr,2);
      }
      if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
    }
  }
  while (prime<=bound);
  if (!flbou)
  {
    flbou=1;
    if (DEBUGLEVEL)
    { fprintferr("\nStarting rayclassno computations\n"); flusherr(); }
    tetpil=avma; z=gerepile(av,tetpil,gcopy(z));
    av1=avma; raylist=bigcgetvec(bound);
	/* maintenant on suit rayclassnolist */
    for (i=1; i<=bound; i++)
    {
      sous=getcompobig(z,i); sousray=rayclassnointern(sous,clh);
      putcompobig(raylist,i,sousray);
    }
  }
  if (DEBUGLEVEL)
  { fprintferr("avma = %ld, t(r) = %ld ",avma-bot,taille2(raylist)); flusherr(); }
  tetpil=avma; raylist=gerepile(av,tetpil,gcopy(raylist));
  if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
  if (DEBUGLEVEL)
  {
    fprintferr("Time for zidealstarlist: %ld\n",timer2()); flusherr();
  }
/* maintenant on suit discrayabslist */
  if (DEBUGLEVEL)
  {
    fprintferr("Starting discrayabs computations\n"); flusherr();
  }
  av1=avma; lim=(avma+bot)>>1; disclist=bigcgetvec(bound);
  for (ii=1; ii<=bound; ii++) putcompobig(disclist,ii,cgetg(1,t_VEC));
  if (nba) module=cgetg(3,t_VEC);
  for (ii=1; ii<=bound; ii++)
  {
    if (DEBUGLEVEL&&(ii%100==0)) { fprintferr("%ld ",ii); flusherr(); }
    sous=getcompobig(raylist,ii);
    ly=lg(sous); sousdisc=cgetg(ly,t_VEC); putcompobig(disclist,ii,sousdisc);
    for (jj=1; jj<ly; jj++)
    {
      bidsimp=(GEN)sous[jj]; clhray=itos((GEN)bidsimp[2]);
      fa=(GEN)bidsimp[1]; ideal=idmat(degk);
      fa2=(GEN)fa[1]; ex=(GEN)fa[2]; fac=gcopy(fa);
      idealrel=cgetg(3,t_MAT); idealrel[1]=lgetg(1,t_COL); idealrel[2]=lgetg(1,t_COL);
      lfa2=lg(fa2);
      for (k=1; k<lfa2; k++)
      {
	fauxpr=(GEN)fa2[k]; ep=itos((GEN)ex[k]); ffs=itos(fauxpr);
	fs=(long)(ffs/degk); resp=fs%degk+1; gprime=stoi((long)(fs/degk));
	pari_randseed=1; vraipr=(GEN)primedec(nf,gprime)[ffs%degk+1];
	if (nba)
	  ideal=idealmul(nf,ideal,idealpow(nf,vraipr,(GEN)ex[k]));
	som=0; clhss=0;
	normp=gpuigs(gprime,resp); normps=itos(normp); normi=ii;
	normp=cgetg(3,t_MAT); no1=cgetg(2,t_COL); no1[1]=(long)gprime; normp[1]=(long)no1;
	no2=cgetg(2,t_COL); no2[1]=lstoi(resp); normp[2]=(long)no2;
	for (j=1; j<=ep; j++)
	{
	  if (clhss==1) som++;
	  else
	  {
	    if (j<ep) { coeff(fac,k,2)=lstoi(ep-j); fad=fac; }
	    else
	    {
	      fad=cgetg(3,t_MAT); fad1=cgetg(lfa2-1,t_COL); fad2=cgetg(lfa2-1,t_COL);
	      fad[1]=(long)fad1; fad[2]=(long)fad2;
	      for (i=1; i<k; i++) { fad1[i]=coeff(fac,i,1); fad2[i]=coeff(fac,i,2); }
	      for (; i<lfa2-1; i++) { fad1[i]=coeff(fac,i+1,1); fad2[i]=coeff(fac,i+1,2); }
	    }
	    normi/=normps;
	    clhss=itos(rayclassnolistessimp(getcompobig(raylist,normi),fad));
	    if ((j==1)&&(clhss==clhray)){ clhray=0; goto LDISCRAY; }
	    som+=clhss;
	  }
	}
	coeff(fac,k,2)=ex[k];
	idealrel=factormul(idealrel,factorpow(normp,som));
      }
      dlk=factordivexact(factorpow(factor(stoi(ii)),clhray),idealrel);
      if (nba)
      {
	module[1]=(long)ideal; arch2=gcopy(arch); module[2]=(long)arch2;
	nbdezero=0;
	for (k=1; k<=r1; k++)
	{
	  if (signe(arch[k]))
	  {
	    arch2[k]=zero;
	    clhss=itos(rayclassno(bnf,module));
	    arch2[k]=un;
	    if ((clhss==clhray)){ clhray=0; goto LDISCRAY; }
	  }
	  else nbdezero++;
	}
      }
      else nbdezero=r1;
      LDISCRAY:
      if (!clhray)
      {
	p1=cgetg(5,t_VEC); p1[1]=(long)fa; p1[2]=p1[3]=p1[4]=zero;
	sousdisc[jj]=(long)p1;
      }
      else
      {
	p3=factorpow(factor(dkabs),clhray); n=clhray*degk; R1=nbdezero*clhray;
	if (((n-R1)&3)==2)
	{
	  normp=cgetg(3,t_MAT); no1=cgetg(2,t_COL); normp[1]=(long)no1; no1[1]=lstoi(-1);
	  no2=cgetg(2,t_COL); normp[2]=(long)no2; no2[1]=un;
	  dlk=factormul(normp,dlk);
	}
	p1=cgetg(5,t_VEC); p1[1]=(long)fa;
	p1[2]=lstoi(n); p1[3]=lstoi(R1); p1[4]=(long)factormul(dlk,p3);
	sousdisc[jj]=(long)p1;
      }
    }
    if (avma<lim)
    {
      if (DEBUGLEVEL)
      { fprintferr("avma = %ld, t(d) = %ld ",avma-bot,taille2(disclist)); flusherr(); }
      tetpil=avma; disclist=gerepile(av1,tetpil,gcopy(disclist));
      if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
    }
  }
  if (DEBUGLEVEL)
  { fprintferr("Time for discrayabs: %ld\n",timer2()); flusherr(); }
  tdi=taille2(disclist);
  if (DEBUGLEVEL)
  { fprintferr("avma = %ld, t(d) = %ld ",avma-bot,tdi); flusherr(); }
  if (tdi<avma-bot)
  {
    tetpil=avma; disclist=gerepile(av0,tetpil,gcopy(disclist));
    if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
  }
  return disclist;
}

static GEN
discrayabslistarchall(GEN bnf, long bound)
/* fait tout a partir du debut, et bound peut aller jusqu'a 2^30. Pour
   l'instant ne s'occupe pas des sous-groupes.
   le format de sortie est le suivant: un vecteur vext dont les composantes
   vint ont exactement 2^LGVINT vraies composantes sauf le dernier qui peut
   etre plus court. vext[i][j] (ou j<=2^LGVINT) doit etre compris comme la
   composante d'indice I=(i-1)*2^LGVINT+j d'un grand vecteur unique V.
   Une telle composante d'indice I est un vecteur indexe par tous les ideaux
   de norme egal a I. Si m_0 est un tel ideal, la composante correspondante
   est la suivante: [m_0,V] ou V est un vecteur de 2^r1 composantes, donnant
   pour chaque arch, le triplet [N,R1,D], ou N, R1, D sont comme dans
   discrayabs sauf que D est sous forme factorisee. L'ordre des arch est
   l'ordre lexicographique inverse, donc [0,0,..,0], [1,0,..,0], [0,1,..,0],...
   */
{
  byteptr ptdif=diffptr;
  long diff,prime=0,degk,lim,av0,av,av1,tetpil,i,j,k,p2s,lfa,lp1,sqbou,cex;
  long fs,resp,flbou,tdi,nba,k2,karch,kka,nbarch,jjj;
  uLong q;
  long ii,jj,ly,clhray,lfa2,ep,som,clhss,normps,normi,nbdezero,r1,R1,n,lp4,c;
  GEN nf,p,z,pol,p1,p2,p3,fa,pr,normp,ideal,bidp,z2,pourz1,matarchunit;
  GEN bigres,funits,racunit,embunit,sous,clh,sousray,raylist,fadkabs;
  GEN clhrayall,discall,arch;
  GEN sousdisc,fa2,ex,fac,no1,no2,fad,fad1,fad2,dkabs,pz;
  GEN idealrel,dlk,disclist,bidsimp,p4,faussefa,pex,fauxpr,gprime;
  GEN *gptr[2];

/* ce qui suit recopie d'assez pres ideallistzstarall */

  if (DEBUGLEVEL) timer2();
  av0=avma; checkbnf(bnf); flbou=0;
  nf=(GEN)bnf[7]; bigres=(GEN)bnf[8]; pol=(GEN)nf[1]; degk=lgef(pol)-3;
  r1=itos((GEN)((GEN)nf[2])[1]); dkabs=gabs((GEN)nf[3],0);
  fadkabs=factor(dkabs); clh=(GEN)((GEN)bigres[1])[1];
  if (lg(bigres)!=5)
  {
    if (lg(bigres)!=7) err(talker,"incorrect big number field");
    else funits=(GEN)bigres[5];
  }
  else funits=(GEN)buchfu(bnf)[1];
  racunit=(GEN)((GEN)bigres[4])[2];
  p=cgeti(3); p[1]=evalsigne(1)+evallgef(3);
  sqbou=itos(racine(stoi(bound)))+1;
  arch=cgetg(r1+1,t_VEC); for (i=1; i<=r1; i++) arch[i]=un;
  pourz1=cgetg(3,t_VEC); pourz1[1]=(long)idmat(degk); pourz1[2]=(long)arch;
  matarchunit=logunitmatrix(nf,funits,racunit,zidealstarinitall(nf,pourz1,0));
  av=avma; lim=(bot+avma)>>1;
  z=bigcgetvec(bound); for (i=2; i<=bound; i++) putcompobig(z,i,cgetg(1,t_VEC));
  bidp=zidealstarinitall(nf,idmat(degk),0);
  embunit=logunitmatrix(nf,funits,racunit,bidp);
  p1=cgetg(2,t_VEC); putcompobig(z,1,p1); p1[1]=(long)zsimp(bidp,embunit);
  diff= *ptdif++; prime+=diff; if (!diff) err(primer1);
  if (DEBUGLEVEL) fprintferr("Starting zidealstarunits computations\n");
  do
  {
    p[2]=prime;
    if ((!flbou)&&(prime>sqbou))
    {
      flbou=1;
      if (DEBUGLEVEL)
      { fprintferr("\nStarting rayclassno computations\n"); flusherr(); }
      tetpil=avma; z=gerepile(av,tetpil,gcopy(z));
      av1=avma; raylist=bigcgetvec(bound);
      /* maintenant on suit rayclassnolist */
      for (i=1; i<=bound; i++)
      {
	sous=getcompobig(z,i);
	sousray=rayclassnointernarch(sous,clh,matarchunit);
	putcompobig(raylist,i,sousray);
      }
      tetpil=avma; raylist=gerepile(av1,tetpil,gcopy(raylist));
      z2=bigcgetvec(sqbou);
      for (i=1; i<=sqbou; i++) { p1=gcopy(getcompobig(z,i)); putcompobig(z2,i,p1); }
      z=z2;
    }
    pari_randseed=1; fa=primedec(nf,p); lfa=lg(fa)-1;
    if (flbou&&(lfa==2)&&(degk==2)) lfa=1;
    for (j=1; j<=lfa; j++)
    {
      pr=(GEN)fa[j];
      if (DEBUGLEVEL) { fprintferr("%ld ",prime); flusherr(); }
      normp=gpui(p,(GEN)pr[4],0); cex=0;
      if (gcmpgs(normp,bound)<=0)
      {
	fauxpr=stoi(prime*degk*degk+(itos((GEN)pr[4])-1)*degk+j-1);
	q=p2s=itos(normp); ideal=pr;
	while ((uLong)q<=(uLong)bound)
	{
	  bidp=zidealstarinitall(nf,ideal,0);
	  faussefa=cgetg(3,t_MAT); p1=cgetg(2,t_COL);
	  faussefa[1]=(long)p1; p1[1]=(long)fauxpr;
	  pex=cgetg(2,t_COL); faussefa[2]=(long)pex;
	  cex++; pex[1]=lstoi(cex);
	  embunit=logunitmatrix(nf,funits,racunit,bidp);
	  for (i=q; i<=bound; i+=q)
	  {
	    p1=getcompobig(z,i/q); lp1=lg(p1);
	    if (lp1>1)
	    {
	      p2=cgetg(lp1,t_VEC); c=0;
	      for (k=1; k<lp1; k++)
	      {
		p3=(GEN)p1[k]; if (i>q) { p4=(GEN)((GEN)p3[1])[1]; lp4=lg(p4)-1; }
		if ((i==q)||(!isinvector(p4,fauxpr,lp4)))
		{
		  c++;
/*		  if (i==q) p2[c]=(long)zsimpjoin1(bidp,faussefa,embunit);
		  else */
		  p2[c]=(long)zsimpjoin(p3,bidp,faussefa,embunit);
		}
	      }
	      p3=cgetg(c+1,t_VEC); for (k=1; k<=c; k++) p3[k]=p2[k]; p2=p3;
	      if (c)
	      {
		if (prime<=sqbou)
		{
		  pz=getcompobig(z,i);
		  if (lg(pz)>1) putcompobig(z,i,concat(pz,p2));
		  else putcompobig(z,i,p2);
		}
		else
		{
		  sousray=rayclassnointernarch(p2,clh,matarchunit);
		  putcompobig(raylist,i,sousray);
		}
	      }
	    }
	  }
	  pz=mulss(q,p2s);
	  q=(gcmpgs(pz,bound)>0)?bound+1:pz[2];
	  if ((uLong)q<=(uLong)bound) ideal=idealmul(nf,ideal,pr);
	}
      }
    }
    diff= *ptdif++; prime+=diff; if (!diff) err(primer1);
    if (avma<lim)
    {
      tetpil=avma;
      if (!flbou)
      {
	if (DEBUGLEVEL)
	{ fprintferr("avma = %ld, t(z) = %ld ",avma-bot,taille2(z)); flusherr(); }
	z=gerepile(av,tetpil,gcopy(z));
      }
      else
      {
	if (DEBUGLEVEL)
	{ 
	  fprintferr("avma = %ld, t(r) = %ld ",avma-bot,taille2(raylist));
	  flusherr();
	}
	gptr[0]=&z; gptr[1]=&raylist;
	gerepilemany(av,gptr,2);
      }
      if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
    }
  }
  while (prime<=bound);
  if (!flbou)
  {
    flbou=1;
    if (DEBUGLEVEL)
    { fprintferr("\nStarting rayclassno computations\n"); flusherr(); }
    tetpil=avma; z=gerepile(av,tetpil,gcopy(z));
    av1=avma; raylist=bigcgetvec(bound);
	/* maintenant on suit rayclassnolist */
    for (i=1; i<=bound; i++)
    {
      sous=getcompobig(z,i);
      sousray=rayclassnointernarch(sous,clh,matarchunit);
      putcompobig(raylist,i,sousray);
    }
  }
  if (DEBUGLEVEL)
  { fprintferr("avma = %ld, t(r) = %ld ",avma-bot,taille2(raylist)); flusherr(); }
  tetpil=avma; raylist=gerepile(av,tetpil,gcopy(raylist));
  if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
  if (DEBUGLEVEL)
  {
    fprintferr("Time for zidealstarlist: %ld\n",timer2()); flusherr();
  }
/* maintenant on suit discrayabslist */
  if (DEBUGLEVEL)
  {
    fprintferr("Starting discrayabs computations\n"); flusherr();
  }
  av1=avma; lim=(avma+bot)>>1; disclist=bigcgetvec(bound);
  for (ii=1; ii<=bound; ii++) putcompobig(disclist,ii,cgetg(1,t_VEC));
  for (ii=1; ii<=bound; ii++)
  {
    sous=getcompobig(raylist,ii);
    ly=lg(sous); sousdisc=cgetg(ly,t_VEC); putcompobig(disclist,ii,sousdisc);
    for (jj=1; jj<ly; jj++)
    {
      bidsimp=(GEN)sous[jj]; clhrayall=(GEN)bidsimp[2];
      fa=(GEN)bidsimp[1];
      fa2=(GEN)fa[1]; ex=(GEN)fa[2]; lfa2=lg(fa2); nbarch=(1<<r1);
      discall=cgetg(nbarch+1,t_VEC);
      for (karch=0; karch<nbarch; karch++)
      {
	kka=karch;
	for (nba=0,jjj=1; jjj<=r1; jjj++)
	{
	  if (kka%2) nba++;
	  kka>>=1;
	}
	clhray=itos((GEN)clhrayall[karch+1]);
	for (k2=1,k=1; k<=r1; k++,k2<<=1)
	{
	  if ((karch&k2)&&(clhray==itos((GEN)clhrayall[karch-k2+1])))
	  { clhray=0; goto LDISCRAYA; }
	}
	fac=gcopy(fa);
	idealrel=cgetg(3,t_MAT); idealrel[1]=lgetg(1,t_COL); idealrel[2]=lgetg(1,t_COL);
	for (k=1; k<lfa2; k++)
	{
	  fauxpr=(GEN)fa2[k]; ep=itos((GEN)ex[k]); fs=itos(fauxpr);
	  fs/=degk; resp=fs%degk+1; gprime=stoi((long)(fs/degk));
	  som=0; clhss=0;
	  normp=gpuigs(gprime,resp); normps=itos(normp); normi=ii;
	  normp=cgetg(3,t_MAT); no1=cgetg(2,t_COL); no1[1]=(long)gprime; normp[1]=(long)no1;
	  no2=cgetg(2,t_COL); no2[1]=lstoi(resp); normp[2]=(long)no2;
	  for (j=1; j<=ep; j++)
	  {
	    if (clhss==1) som++;
	    else
	    {
	      if (j<ep) { coeff(fac,k,2)=lstoi(ep-j); fad=fac; }
	      else
	      {
		fad=cgetg(3,t_MAT); fad1=cgetg(lfa2-1,t_COL); fad2=cgetg(lfa2-1,t_COL);
		fad[1]=(long)fad1; fad[2]=(long)fad2;
		for (i=1; i<k; i++) { fad1[i]=coeff(fac,i,1); fad2[i]=coeff(fac,i,2); }
		for (; i<lfa2-1; i++) { fad1[i]=coeff(fac,i+1,1); fad2[i]=coeff(fac,i+1,2); }
	      }
	      normi/=normps;
	      clhss=itos((GEN)rayclassnolistessimp(getcompobig(raylist,normi),fad)[karch+1]);
	      if ((j==1)&&(clhss==clhray)){ clhray=0; goto LDISCRAYA; }
	      som+=clhss;
	    }
	  }
	  coeff(fac,k,2)=ex[k];
	  idealrel=factormul(idealrel,factorpow(normp,som));
	}
	dlk=factordivexact(factorpow(factor(stoi(ii)),clhray),idealrel);
	nbdezero=r1-nba;
	LDISCRAYA:
	if (!clhray)
	{
	  p1=cgetg(4,t_VEC); p1[1]=p1[2]=p1[3]=zero;
	  discall[karch+1]=(long)p1;
	}
	else
	{
	  p3=factorpow(fadkabs,clhray); n=clhray*degk; R1=nbdezero*clhray;
	  if (((n-R1)&3)==2)
	  {
	    normp=cgetg(3,t_MAT); no1=cgetg(2,t_COL); normp[1]=(long)no1; no1[1]=lstoi(-1);
	    no2=cgetg(2,t_COL); normp[2]=(long)no2; no2[1]=un;
	    dlk=factormul(normp,dlk);
	  }
	  p1=cgetg(4,t_VEC); p1[1]=lstoi(n); p1[2]=lstoi(R1);
	  p1[3]=(long)factormul(dlk,p3); discall[karch+1]=(long)p1;
	}
      }
      p1=cgetg(3,t_VEC); p1[1]=(long)fa; p1[2]=(long)discall;
      sousdisc[jj]=(long)p1;
    }
    if (avma<lim)
    {
      if (DEBUGLEVEL)
      { fprintferr("avma = %ld, t(d) = %ld ",avma-bot,taille2(disclist)); flusherr(); }
      tetpil=avma; disclist=gerepile(av1,tetpil,gcopy(disclist));
      if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
    }
  }
  if (DEBUGLEVEL)
  { fprintferr("Time for discrayabs: %ld\n",timer2()); flusherr(); }
  tdi=taille2(disclist);
  if (DEBUGLEVEL)
  { fprintferr("avma = %ld, t(d) = %ld ",avma-bot,tdi); flusherr(); }
  if (tdi<avma-bot)
  {
    tetpil=avma; disclist=gerepile(av0,tetpil,gcopy(disclist));
    if (DEBUGLEVEL) { fprintferr("avma = %ld ",avma-bot); flusherr(); }
  }
  return disclist;
}

GEN
discrayabslistlong(GEN bnf, long bound)
{
  return discrayabslistarch(bnf,gzero,bound);
}

GEN
discraylist0(GEN bnf, GEN borne, GEN arch, long all)
{
  if (all)
    return discrayabslistarchall(bnf,itos(borne));

  if (typ(borne)==t_INT)
    return discrayabslistarch(bnf,arch,itos(borne));

  return discrayabslist(bnf,borne);
}

GEN
decodemodule(GEN nf, GEN fa)
{
  long n,k,j,fauxpr,av=avma,tetpil;
  GEN fa2,ex,id,pr;

  nf=checknf(nf);
  if (typ(fa)!=t_MAT || lg(fa)!=3)
    err(talker,"incorrect factorisation in decodemodule");
  n=lgef(nf[1])-3; id=idmat(n);
  fa2=(GEN)fa[1]; ex=(GEN)fa[2];
  for (k=1; k<lg(fa2); k++)
  {
    fauxpr=itos((GEN)fa2[k]);
    j=(fauxpr%n)+1; fauxpr/=(n*n);
    pari_randseed=1; pr=(GEN)primedec(nf,stoi(fauxpr))[j];
    id=idealmul(nf,id,idealpow(nf,pr,(GEN)ex[k]));
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(id));
}

GEN
decodefactor(GEN fa)
{
  long av=avma,tetpil,k;
  GEN fa2,ex,res;

  if (typ(fa)!=t_MAT || lg(fa)!=3)
    err(talker,"incorrect factorisation in decodefactor");
  fa2=(GEN)fa[1]; ex=(GEN)fa[2]; res=gun;
  for (k=1; k<lg(fa2); k++)
    res=gmul(res,gpui((GEN)fa2[k],(GEN)ex[k],0));
  tetpil=avma; return gerepile(av,tetpil,gcopy(res));
}
